# configGen.tcl - configuration file generator
#
# modification history
# --------------------
# 01e,08augo5,pee  sourcing cmpScriptLib instead of prjLib
# 01d,23dec04,c_c  removed references to foundation.
# 01c,01sep04,fle  Made it use Wind::foundation when needed
# 01b,30jun03,fle  adapted to new osconfig tree structure
# 01a,12may98,ms    written
#
#
# DESCRIPTION
# This file generates the configuration files config.h, linkSyms.c, and
# sysConfig.c from a configuration descriptor file (.wcf).
#
# USAGE
#        wtxtcl configGen.tcl prjFile
#                prjFile	project file
#        RETURNS: An error string, which is empty on success
#        PRODUCES: files config.h, sysConfig.c, and linkSyms.c
#

# parse and check arguments

package require Wind

set usage "tclsh configGen.tcl prjFile"
if {$argc != 1} {
    error "wrong # args. Usage: $usage"
}

# generate the configuration files

source [file join [Wind::base] host resource osconfig tcl cmpScriptLib.tcl]

set prjFile	[lindex $argv 0]
set hProj	[prjOpen $prjFile]

::prj_vxWorks_hidden::configGen $hProj

prjClose $hProj
