# pkgIndex.tcl - OsConfig Tcl package index

# Copyright 2003-2004 Wind River Systems,  Inc.

# modification history
# --------------------
# 01m,14sep05,pee  added two new functions.
# 01l,20oct04,fle  SPR#102786 : added cmpSizeGet
# 01k,11oct04,fle  SPR#102448 : Added cmpBundleExcludedListGet
# 01j,01oct04,fle  Added cmpProfileListGet procedure
# 01i,08sep04,fle  SPR#88074 : added cmpMakefile
# 01h,30aug04,fle  renamed cmpStdoutGet to cmpStdout, and added cmpStderr
# 01g,20aug04,fle  Added cmpStdoutSet and cmpParamRemove
# 01f,14jul04,fle  Added cmpDependenciesGet
# 01e,18may04,fle  Added cmpBuildRuleXxx procedures
# 01d,14may04,fle  Added cmpBspListGet and cmpToolListGet
# 01c,31mar04,fle  Added FileLib::find
# 01b,10mar04,fle  Removed Cache procedures from DataDocs package
# 01a,13feb04,fle  speed up package use

package ifneeded OsConfig 1.0 [ \
    list tclPkgSetup $dir OsConfig 1.0 {
	{ \
	    cmpScriptLib.tcl source { \
		autoscale \
		cmpAdd \
		cmpAddBuildModeEval \
		cmpAddDepends \
		cmpBackup \
		cmpBuild \
		cmpBuildFlagsAdd \
		cmpBuildMacroGet \
		cmpBuildMacroSet \
		cmpBuildModeEval \
		cmpBuildModeGet \
		cmpBuildRule \
		cmpBuildRuleAdd \
		cmpBuildRuleDefault \
		cmpBuildRuleListGet \
		cmpBuildRuleRemove \
		cmpBuildRuleSet \
		cmpBuildSourceEnable \
		cmpBuildSpecCreate \
		cmpBuildSpecSet \
		cmpBundleAdd \
		cmpBundleExcludedListGet \
		cmpBundleGet \
		cmpBundleListGet \
		cmpBundleRemove \
		cmpDependsGet \
		cmpDependenciesGet \
		cmpFileAdd \
		cmpFileListGet \
		cmpFileRemove \
		cmpFsFileAdd \
		cmpFsFileCreate \
		cmpFsFileGet \
		cmpFsFileListGet \
		cmpFsFileRemove \
		cmpInfo \
		cmpListGet \
		cmpLoad \
		cmpMakefile \
		cmpModuleDependsGet \
		cmpOsName \
		cmpParamGet \
		cmpParamRemove \
		cmpParamSet \
		cmpProcAdd \
		cmpProcListGet \
		cmpProcRemove \
		cmpProjClose \
		cmpProfileGet \
		cmpProfileInitGet \
		cmpProfileInitSet \
		cmpProfileListGet \
		cmpProjCopy \
		cmpProjCreate \
		cmpProjDelete \
		cmpProjFileGet \
		cmpProjHandleGet \
		cmpProjOpen \
		cmpProjTcGet \
		cmpRemove \
		cmpRemoveBuildModeEval \
		cmpRemoveDepends \
		cmpRestore \
		cmpSave \
		cmpSizeGet \
		cmpStderr \
		cmpStdout \
		cmpSysLayerGet \
		cmpTest \
		cmpTreeGet \
		cmpUnavailListGet \
		cmpValidate \
		cmpBspListGet \
		cmpToolListGet \
		cmpProfileAdd \
		cmpDefaultProfileGet \
	    } \
	} \
    } \
]

# define the datadoc libraries names

package ifneeded DataDocs 1.0 [ \
    list tclPkgSetup $dir DataDocs 1.0 {
	{ \
	    dataDocLib.tcl source { \
		cSymsDemangle \
		cSymsMangle \
		componentSizeTest \
		cxrCmpInfoGet \
		cxrDataDocCreate \
		cxrDependsGet \
		cxrIncludeDefaultComponentsOfIncludedSelections \
		cxrSetValidate \
		cxrSizeGet \
		cxrSubfolders \
		cxrSubtree \
		cxrSupertree \
		cxrUnavailListGet \
		defaultFolderSubTree \
		docCreate \
		docWalk \
		foldersDeletableComponentsGet \
		modAnalyze \
		modCalledBy \
		modCalls \
		modInfo \
		modSubtree \
		modSupertree \
		modTrace \
		mxrDataDocCreate \
		mxrDocValidate \
		mxrLibsContract \
		mxrLibsExpand \
		mxrOnlyOne \
		mxrPrjHandleGet \
		mxrSizeGet \
		mxrSizeTest \
		mxrSplitErrorOutput \
		mxrSubtree \
		mxrSubtreeTest \
		mxrSupertree \
		mxrSupertreeTest \
		mxrTcGet \
		mxrUsers \
		mxrUses \
	    } \
	} \
    } \
]

package ifneeded PrjUtils 1.0 [ \
    list tclPkgSetup $dir PrjUtils 1.0 {
	{ \
	    Utils.tcl source { \
		flagFind \
		printStack \
		FileTails \
		bspsEnumerate \
		cdr \
		ifaceValidate \
		outOfDate \
		minModTime \
		EscapeRegexpCharacters \
		removeDuplicatesFromList \
		mTimeGet \
		shareDllLoad \
		filePathToAbsolute \
		NativeFileNames \
		mapcar \
		toPrjDirAbsolute \
		tempFileGet \
		removeTrailingSlash \
		flagValueGet \
		filenameQuoteIfNecessary \
		pathTruncate \
		buildRuleSplit \
		filePathFix \
		filePathUnFix \
		projectsEnumerate \
		buildRuleJoin \
		tcInfoFileGet \
		car \
		isFileNameOk \
		badFileCharsGet \
		filePathEatDots \
		inherit \
		regsubPath \
		preferredPageSort \
		isXmlFile \
		maxModTime \
		::PrjUtils::archDirFind \
		::PrjUtils::barePathSubstitute \
		::PrjUtils::defaultDir \
		::PrjUtils::relPath \
		::PrjUtils::srcDir \
		::Object::evaluate \
		::Object::create \
		::Object::nameExtract \
		::Object::uniqueNameCreate \
		::Object::test \
		::Null::Type \
		::Null::Name \
		::Null::DisplayName \
	    } \
	} \
	{ \
	    FileLib.tcl source { \
		FileLib::copy \
		FileLib::find \
		FileLib::listGet \
		FileLib::listDelete \
	    } \
	} \
    } \
]
