/* archArmCommon.h - common Arm architecture specific header */

/*
* Copyright (c) 2003-2004, 2006 Wind River Systems, Inc.
*
* The right to copy, distribute, modify or otherwise make use
* of this software may be licensed only pursuant to the terms
* of an applicable Wind River license agreement.
*/

/*
modification history
--------------------
01h,02feb06,mil  Updated for POSIX namespace conformance.
01g,08sep04,scm  move INSTR from archArm.h
01e,25aug04,scm  move to portable trcLib...
01d,03aug04,scm  Enable Coprocessor Abstraction, disable Portable trcLib.
01c,25nov03,pes  Move setting of _BYTE_ORDER macro into archArmCommon.h
01b,12nov03,job  Moved some blib stuff from archArm.h
01a,11nov03,pes  written.
*/

#ifndef __INCarchArmCommonh
#define __INCarchArmCommonh

#ifdef __cplusplus
extern "C" {
#endif

#if defined(ARMEB) || defined(__ARMEB__)
#define	_BYTE_ORDER		_BIG_ENDIAN
#else
#define	_BYTE_ORDER		_LITTLE_ENDIAN
#endif


#if !defined(_POSIX_C_SOURCE) && !defined(_XOPEN_SOURCE) && \
    !defined(_POSIX_AEP_RT_CONTROLLER_C_SOURCE)

/* from bLib.c */

#define _WRS_BLIB_ALIGNMENT     3       /* quad byte alignment mask */
#define swab_PORTABLE
#define _WRS_IMPROVED_PORTABLE_SWAB

/* Enable Coprocessor Abstraction.  Must do all or none. */
	
#define _WRS_PAL_COPROC_LIB

/* Disable Portable trcLib */

#define trcLib_PORTABLE

#ifndef _ASMLANGUAGE
#if     (ARM_THUMB)
typedef unsigned short INSTR;           /* 16 bit instructions */
#else /* ARM_THUMB */
typedef unsigned long INSTR;            /* 32 bit word-aligned instructions */
#endif /* ARM_THUMB */
#endif /* _ASMLANGUAGE */

#endif  /* _POSIX_xxx_SOURCE */


#ifdef __cplusplus
}
#endif

#endif /* __INCarchArmCommonh */
