/* archColdfireCommon.h - common Coldfire architecture specific header */

/* 
Copyright (c) 2005-2006 Wind River Systems, Inc. 

The right to copy, distribute, modify or otherwise make use 
of this software may be licensed only pursuant to the terms 
of an applicable Wind River license agreement. 
*/

/*
modification history
--------------------
01e,14feb06,pes  Updated for POSIX namespace conformance
01d,17nov05,scm  correct definition of INSTR...
01c,18aug05,rec  move syscall trap definition here
01b,23jun05,rec  moved trcLib_PORTABLE from archColdfireCommon.h
01a,13may05,rec  writen
*/

#ifndef __INCarchColdfireCommonh
#define __INCarchColdfireCommonh

#ifdef __cplusplus
extern "C" {
#endif

#if !defined(_POSIX_C_SOURCE) && !defined(_XOPEN_SOURCE) && \
    !defined(_POSIX_AEP_RT_CONTROLLER_C_SOURCE)

#define SYSCALL_TRAP_NUM    3                   /* syscall trap number */

/*
 * Macros to obain FP and return PC from jmp_buf[] array.
 * On the user side, these macros are dependent on the setjmp()
 * implementation in the compiler library.
 *
 * The frame pointer represents the SP at the entry of setjmp(), and
 * the return PC is the next instruction address from where setjmp()
 * was called.
 * see target/usr/src/tool/diab/libc/cf/setjmp.s for register placement
 */

#define _WRS_FRAMEP_FROM_JMP_BUF(env)   ((char *) env[14])  /* A7 */
#define _WRS_RET_PC_FROM_JMP_BUF(env)   ((INSTR *) env[13]) /* A6 */


/* Enable Coprocessor Abstraction.  Must do all or none. */
        
#define _WRS_PAL_COPROC_LIB

#define trcLib_PORTABLE

#ifndef _ASMLANGUAGE
typedef unsigned short INSTR;           /* 16 bit instructions */
#endif /* _ASMLANGUAGE */

#endif  /* _POSIX_xxx_SOURCE */

#ifdef __cplusplus
}
#endif

#endif /* __INCarchColdfireCommonh */
