/* elfColdfire.h - Coldfire specific elf loader header */

/* 
Copyright (c) 1996,2005 Wind River Systems, Inc. 

The right to copy, distribute, modify or otherwise make use 
of this software may be licensed only pursuant to the terms 
of an applicable Wind River license agreement. 
*/

/*
modification history
--------------------
01c,27jun05,rec  review comments
01b,14jun05,rec  detab file
01a,14oct96,mem  created, based on elfPpc.h ver 01c.
*/

#ifndef __INCelfColdfireh
#define __INCelfColdfireh

#ifdef __cplusplus
extern "C" {
#endif

#define EM_ARCH_MACHINE         EM_68K

#define CHECK_LOW16(val)        (((val & 0xffff8000) == 0) ||           \
                                 ((val & 0xffff8000) == 0xffff8000))

#define CHECK_LOW16_STRICT(val) (((val & 0xffff0000) == 0) ||           \
                                 ((val & 0xffff0000) == 0xffff0000))

/* 68k relocations (rela type) */

#define R_COLDFIRE_NONE              0
#define R_COLDFIRE_32                1
#define R_COLDFIRE_16                2
#define R_COLDFIRE_PC32              4
#define R_COLDFIRE_PC16              5
#define R_COLDFIRE_SDA32             180
#define R_COLDFIRE_SDA16             181

#ifdef __cplusplus
}
#endif

#endif /* __INCelfColdfireh */
