/* sigColdfireCodes.h - Coldfire codes sent to signal handlers */

/* 
Copyright (c) 2000,2005 Wind River Systems, Inc. 

The right to copy, distribute, modify or otherwise make use 
of this software may be licensed only pursuant to the terms 
of an applicable Wind River license agreement. 
*/

/*
modification history
--------------------
01b,14jun05,rec  detab file
01a,17mar00,dra  Written based on T1.0.1 Coldfire and T2 m68k
*/

#ifndef __INCsigColdfireCodesh
#define __INCsigColdfireCodesh

#ifdef __cplusplus
extern "C" {
#endif

#include <iv.h>

#define SEGV_BUS_ERROR          IV_BUS_ERROR
#define BUS_ADDERR              IV_ADDRESS_ERROR
#define ILL_ILLINSTR_FAULT      IV_ILLEGAL_INSTRUCTION
#define FPE_INTDIV_TRAP         IV_ZERO_DIVIDE
#define FPE_CHKINST_TRAP        IV_CHK_INSTRUCTION
#define FPE_TRAPV_TRAP          IV_TRAP_INSTRUCTION
#define ILL_PRIVVIO_FAULT       IV_PRIVILEGE_VIOLATION
#define TRAP_TRACE              IV_TRACE
#define EMT_EMU1010             IV_LINE_1010_EMULATOR
#define EMT_EMU1111             IV_LINE_1111_EMULATOR
#define ILL_COPROCERR_FAULT     IV_CP_PROTOCOL_VIOLATION
#define FMT_FORMAT_ERROR        IV_FORMAT_ERROR
#define FPE_FLTBSUN_TRAP        IV_FPCP_B_S_U_CONDITION
#define FPE_FLTINEX_TRAP        IV_FPCP_INEXACT_RESULT
#define FPE_FLTDIV_TRAP         IV_DIVIDE_BY_ZERO
#define FPE_FLTUND_TRAP         IV_UNDERFLOW
#define FPE_FLTOPERR_TRAP       IV_OPERAND_ERROR
#define FPE_FLTOVF_TRAP         IV_OVERFLOW
#define FPE_FLTNAN_TRAP         IV_SIGNALING_NAN

#ifdef __cplusplus
}
#endif

#endif /* __INCsigColdfireCodesh */
