/* vxColdfireLib.h - header for board dependent library routines for the Coldfire */

/* 
Copyright (c) 2000,2005, 2006 Wind River Systems, Inc. 

The right to copy, distribute, modify or otherwise make use 
of this software may be licensed only pursuant to the terms 
of an applicable Wind River license agreement. 
*/

/*
modification history
--------------------
01g,25apr06,rec  SPR-120223 decouple aimMmu from taskArchLib
01f,15mar06,rec  SPR-118786 - add func_taskMmuCtxPut
01e,31jan06,rec  change function pointers for mmu context save/restore
01d,07jan06,rec	 MMU changes - add func_taskMmuCtxSet
01c,01jul05,rec	 review comments
01b,14jun05,rec	 detab file
01a,17mar00,dra	 Written based on T1.0.1 Coldfire and T2 m68k
*/

#ifndef __INCvxColdfireLibh
#define __INCvxColdfireLibh

#ifdef __cplusplus
extern "C" {
#endif

/* function declarations */

#ifndef _ASMLANGUAGE

IMPORT void	vxSSEnable (void);
IMPORT void	vxSSDisable (void);

IMPORT void	vxMacSupport(BOOL en);

IMPORT VOIDFUNCPTR func_taskMmuCtxSave;	
IMPORT VOIDFUNCPTR func_taskMmuCtxPut;	
IMPORT VOIDFUNCPTR func_taskUserMmuCtxSet;
IMPORT VOIDFUNCPTR func_taskMmuCtxRestore;	

#endif	/* _ASMLANGUAGE */

#ifdef __cplusplus
}
#endif

#endif /* __INCvxColdfireLibh */
