/* archShCommon.h - common Sh architecture specific header */

/*
* Copyright (c) 2003-2006 Wind River Systems, Inc.
*
* The right to copy, distribute, modify or otherwise make use
* of this software may be licensed only pursuant to the terms
* of an applicable Wind River license agreement.
*/

/*
modification history
--------------------
01e,02feb06,mil  Updated for POSIX namespace conformance.
01d,29apr04,h_k  enabled coprocessor abstraction.
01c,22mar04,zl   moved trcLib_PORTABLE and INSTR definitions here.
01b,12nov03,job  Moved some blib stuff from archSh.h
01a,11nov03,pes  written.
*/

#ifndef __INCarchShCommonh
#define __INCarchShCommonh

#ifdef __cplusplus
extern "C" {
#endif

#if !defined(_POSIX_C_SOURCE) && !defined(_XOPEN_SOURCE) && \
    !defined(_POSIX_AEP_RT_CONTROLLER_C_SOURCE)

#define _WRS_PAL_COPROC_LIB		/* enable coprocessor abstraction */

/* from bLib.c */

#define _WRS_BLIB_ALIGNMENT     3       /* quad byte alignment mask */
#define swab_PORTABLE

/* from trcLib.c */

#define trcLib_PORTABLE

/* moved here from h/types/vxTypesOld.h */

#ifndef _ASMLANGUAGE
typedef unsigned short INSTR;		/* word-aligned instructions */
#endif /* _ASMLANGUAGE */

#endif  /* _POSIX_xxx_SOURCE */


#ifdef __cplusplus
}
#endif

#endif /* __INCarchShCommonh */




