/* b_off_t.h - base type off_t definition header */

/*
 * Copyright (c) 2006 Wind River Systems, Inc.
 *
 * The right to copy, distribute or otherwise make use of this software
 * may be licensed only pursuant to the terms of an applicable Wind River
 * license agreement. 
*/

/*
modification history
--------------------
01b,20mar06,mil  Added protection against user stdio.h off_t definition.
01a,16feb06,pes  Created from types/vxTypes.h.
*/

#ifndef __INCb_off_th
#define __INCb_off_th

#ifdef __cplusplus
extern "C" {
#endif

#if !defined(_DEFINED_off_t) && !defined(_OFF_T)                                
# define _DEFINED_off_t
# define _OFF_T

/* POSIX requires off_t to be a signed int type */
# ifdef __RTP__
typedef long long       off_t;
# else  /* __RTP__ */
typedef long            off_t;

/* below is made compatible with older code that expects
 * off_t64 to be always defined with off_t on the kernel side.
 */
#  ifndef _DEFINED_off_t64
#  define _DEFINED_off_t64
typedef long long       off_t64;
#  endif /* _DEFINED_off_t64 */

# endif /* __RTP__ */

#endif /* _DEFINED_off_t */


#ifdef __cplusplus
}
#endif

#endif /* __INCb_off_th */


