/* b_pthread_attr_t.h - base type pthread_attr_t definition header */

/*
 * Copyright (c) 2006 Wind River Systems, Inc.
 *
 * The right to copy, distribute or otherwise make use of this software
 * may be licensed only pursuant to the terms of an applicable Wind River
 * license agreement. 
*/

/*
modification history
--------------------
01a,16feb06,pes  Created.
*/

#ifndef __INCb_pthread_attr_th
#define __INCb_pthread_attr_th

#ifdef __cplusplus
extern "C" {
#endif


/* typedef size_t */
#include <base/b_size_t.h>

/* typedef sched_param */
#include <base/b_struct_sched_param.h>

#ifndef _DEFINED_pthread_attr_t
#define _DEFINED_pthread_attr_t

#if defined(_POSIX_C_SOURCE) || defined(_XOPEN_SOURCE) || \
    defined(_POSIX_AEP_RT_CONTROLLER_C_SOURCE)

#undef threadAttrStatus
#undef threadAttrStacksize
#undef threadAttrStackaddr
#undef threadAttrGuardsize
#undef threadAttrDetachstate
#undef threadAttrContentionscope
#undef threadAttrInheritsched
#undef threadAttrSchedpolicy
#undef threadAttrName
#undef threadAttrOptions
#undef threadAttrSchedparam
#endif /* _POSIX_xxxx_SOURCE */

typedef struct {
      int     threadAttrStatus;                /* status flag              */
      size_t  threadAttrStacksize;             /* stack size               */
      void *  threadAttrStackaddr;             /* stack address            */
      size_t  threadAttrGuardsize;             /* guard address (RTP only) */
      int     threadAttrDetachstate;           /* detach state             */
      int     threadAttrContentionscope;       /* contention scope         */
      int     threadAttrInheritsched;          /* inherit scheduler        */
      int     threadAttrSchedpolicy;           /* scheduling policy        */
      char *  threadAttrName;         /* task name - VxWorks extension     */
      int     threadAttrOptions;      /* task options - VxWorks extension  */
      struct sched_param threadAttrSchedparam; /* sched param struct       */
    } pthread_attr_t;

#endif /* _DEFINED_pthread_attr_t */

#ifdef __cplusplus
}
#endif

#endif /* __INCb_pthread_attr_th */


