/* b_struct_sched_param.h - base type sched_param definition header */

/*
 * Copyright (c) 2006 Wind River Systems, Inc.
 *
 * The right to copy, distribute or otherwise make use of this software
 * may be licensed only pursuant to the terms of an applicable Wind River
 * license agreement. 
*/

/*
modification history
--------------------
01a,16feb06,pes  Created.
*/

#ifndef __INCb_struct_sched_paramh
#define __INCb_struct_sched_paramh

#ifdef __cplusplus
extern "C" {
#endif


#ifndef _WRS_KERNEL
#include <sys/unistd.h>
#if (_POSIX_SPORADIC_SERVER >= 0) || (_POSIX_THREAD_SPORADIC_SERVER >= 0)
#include <base/b_struct_timespec.h>
#endif  /* _POSIX*_SPORADIC_SERVER >= 0 */
#endif /* _WRS_KERNEL */

#ifndef _DEFINED_struct_sched_param
#define _DEFINED_struct_sched_param

#if defined(_POSIX_C_SOURCE) || defined(_XOPEN_SOURCE) || \
    defined(_POSIX_AEP_RT_CONTROLLER_C_SOURCE)

/*
 * These #undefs are needed because pthread_attr_t uses
 * sched_param as a member. This protects against macro
 * expansion where pthread_attr_t is needed but include of
 * sched.h is illegal (POSIX).
 */

#undef sched_priority
#undef sched_ss_low_priority
#undef sched_ss_repl_period
#undef sched_ss_init_budget
#undef sched_ss_max_repl
#endif  /* _POSIX_xxx_SOURCE */

struct sched_param              /* Scheduling parameter structure */
    {
    int sched_priority;         /* scheduling priority */
#ifndef _WRS_KERNEL
#if (_POSIX_SPORADIC_SERVER >= 0) || (_POSIX_THREAD_SPORADIC_SERVER >= 0)
    int             sched_ss_low_priority;
    struct timespec sched_ss_repl_period;
    struct timespec sched_ss_init_budget;
    int             sched_ss_max_repl;
#endif  /* _POSIX*_SPORADIC_SERVER >= 0 */
#endif  /* _WRS_KERNEL */
    };

#endif  /* _DEFINED_struct_sched_param */

#ifdef __cplusplus
}
#endif

#endif /* __INCb_struct_sched_paramh */


