/*
 * $Log:   V:/PVCSDB/DiskOnChip/archives/Test for 7.x/src/H3/doch_func.h-arc  $
 * 
 *    Rev 1.17   May 18 2006 14:41:20   polina.marimont
 * v1.40Fin1, PVCS log inside
 */

#ifndef DOCH_FUNC_H
#define DOCH_FUNC_H

#include "flcommon.h"
#include "doch_api.h"

#ifdef __cplusplus
extern "C" {
#endif

/*Get Info*/
DOCH_Error DOCHIdentifyDiskOnChipDevice(IOreq* ioreq);
DOCH_Error DOCHGetResetStatus(IOreq* ioreq);
DOCH_Error DOCHNotifyReset(IOreq* ioreq);
DOCH_Error DOCHNotifyPlatformResumed(IOreq* ioreq);
DOCH_Error DOCHPartitionInfo(IOreq* ioreq);
DOCH_Error DOCHSetDiskUserAttributes(IOreq* ioreq);
DOCH_Error DOCHGetDiskUserAttributes(IOreq* ioreq);
DOCH_Error DOCHGetConfigurationData(IOreq* ioreq);
DOCH_Error DOCHSetConfigurationData(IOreq* ioreq);

/*Media*/
DOCH_Error DOCHSetDefaultPartition(IOreq* ioreq);
DOCH_Error DOCHSetDataTransferMode(IOreq* ioreq);
DOCH_Error DOCHOptimizeMedia(IOreq* ioreq);
DOCH_Error DOCHDeletePartitions(IOreq* ioreq);
DOCH_Error DOCHAddPartition(IOreq* ioreq);
DOCH_Error DOCHUnformatDevice(IOreq* ioreq);
DOCH_Error DOCHWriteIPL(IOreq* ioreq);
DOCH_Error DOCHReadIPL(IOreq* ioreq);

/*IO*/
DOCH_Error DOCHReadPartitionSectors(IOreq* ioreq);
DOCH_Error DOCHWritePartitionSectors(IOreq* ioreq);
DOCH_Error DOCHWriteAndLock(IOreq* ioreq);
DOCH_Error DOCHWipeSectors(IOreq* ioreq);
DOCH_Error DOCHFreeSectors(IOreq* ioreq);
DOCH_Error DOCHPrepareForWrite(IOreq* ioreq);

/*Flexi-Flash*/
DOCH_Error DOCHWriteFlexiFast(IOreq* ioreq);
DOCH_Error DOCHWriteFlexiNormal(IOreq* ioreq);
DOCH_Error DOCHReWriteFlexiNormal(IOreq* ioreq);

/*Protection*/
DOCH_Error DOCHAccessPartWithPwd(IOreq* ioreq);
DOCH_Error DOCHDisablePartAccess(IOreq* ioreq);
DOCH_Error DOCHSetParitionProtection(IOreq* ioreq);

/*PKI*/
DOCH_Error DOCHSendHostPublicKey(IOreq* ioreq);
DOCH_Error DOCHReceiveDochPublicKey(IOreq* ioreq);
DOCH_Error DOCHVerifyHostKey(IOreq* ioreq);

/*Custom Parameters*/
DOCH_Error DOCHGetCustomParameter(IOreq* ioreq);
DOCH_Error DOCHSetCustomParameter(IOreq* ioreq);

/*Atomic Read/Write Sequence*/
DOCH_Error DOCHManageAtomicWriteSeq(IOreq* ioreq);

/*Algorithms*/
DOCH_Error DOCHReportSupportedAlgorithms(IOreq* ioreq);
DOCH_Error DOCHGetAlgorithmCapabilities(IOreq* ioreq);
DOCH_Error DOCHSetAlgorithmMode(IOreq* ioreq);

/*Hash*/
DOCH_Error DOCHAutoHashControl(IOreq* ioreq);
DOCH_Error DOCHReadCalculatedHash(IOreq* ioreq);
DOCH_Error DOCHWriteCalculatedHash(IOreq* ioreq);
DOCH_Error DOCHReadOriginalHash(IOreq* ioreq);
DOCH_Error DOCHWriteGivenHash(IOreq* ioreq);
DOCH_Error DOCHStartHashStreamCalculation(IOreq* ioreq);
DOCH_Error DOCHReadStopHashStreamCalc(IOreq* ioreq);
DOCH_Error DOCHReturnRandomNumbers(IOreq* ioreq);
DOCH_Error DOCHSetHashKey(IOreq* ioreq);

/*General*/
DOCH_Error DOCHSetParitionUserAttributes(IOreq* ioreq);
DOCH_Error DOCHGetParitionUserAttributes(IOreq* ioreq);
DOCH_Error DOCHSetPowerMode(IOreq* ioreq);
DOCH_Error DOCHGetPowerMode(IOreq* ioreq);
DOCH_Error DOCHConfigHW(IOreq* ioreq);
DOCH_Error DOCHRecoverFromPowerLoss(IOreq* ioreq);
DOCH_Error DOCHClearIRQ(IOreq* ioreq);
DOCH_Error DOCHGetPhysicalAddress(IOreq* ioreq);

#ifdef __cplusplus
}
#endif

#endif /*DOCH_FUNC_H*/

