/***********************************************************************************/
/*                        M-Systems Confidential                                   */
/*           Copyright (C) M-Systems Flash Disk Pioneers Ltd. 1995-2005            */
/*                         All Rights Reserved                                     */
/***********************************************************************************/
/*                            NOTICE OF M-SYSTEMS OEM                              */
/*                           SOFTWARE LICENSE AGREEMENT                            */
/*                                                                                 */
/*      THE USE OF THIS SOFTWARE IS GOVERNED BY A SEPARATE LICENSE                 */
/*      AGREEMENT BETWEEN THE OEM AND M-SYSTEMS. REFER TO THAT AGREEMENT           */
/*      FOR THE SPECIFIC TERMS AND CONDITIONS OF USE,                              */
/*      OR CONTACT M-SYSTEMS FOR LICENSE ASSISTANCE:                               */
/*      E-MAIL = info@m-sys.com                                                    */
/***********************************************************************************/

/***********************************************************************************/
/*																				   */
/*	Header file for doch_sys module												   */ 
/*																				   */
/***********************************************************************************/

/*
 * $Log:   V:/PVCSDB/DiskOnChip/archives/Test for 7.x/src/H3/doch_sys.h-arc  $
 * 
 *    Rev 1.13   May 18 2006 14:41:20   polina.marimont
 * v1.40Fin1, PVCS log inside
 */

#ifndef DOCH_SYS_H
#define DOCH_SYS_H

#include "flcustom.h"


/* 
 * Access Layer API
 */

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
	unsigned char	(*hal_get_ata_reg)	(volatile unsigned char *base, int reg);
	void			(*hal_set_ata_reg)	(volatile unsigned char *base, int reg, unsigned int val);
	unsigned short	(*hal_get_ctrl_reg)	(volatile unsigned char *base, int reg);
	void			(*hal_set_ctrl_reg)	(volatile unsigned char *base, int reg, unsigned int val);
	int				(*hal_blk_read)		(volatile unsigned char *base, unsigned char *buf, int sectors);
	int				(*hal_blk_write)	(volatile unsigned char *base, unsigned char *buf, int sectors);
	int				(*hal_doch_release)	(int socketNo);
} DOCH_HALRoutnies;

#ifdef __cplusplus
}
#endif
#ifdef FL_MIGRATION_VERSION

#ifndef DOCH_USE_FUNC
#include "flflash.h"
extern FLFlash * DOCHFlash;
#endif /* DOCH_USE_FUNC */

#endif /*FL_MIGRATION_VERSION*/

#endif /* DOCH_SYS_H */




