/* cycleLib.h - clock cycle level event library header */

/* Copyrigt 2005 Wind River Systems, Inc. */
#include "copyright_wrs.h"

/*
modification history
--------------------
01a,06dec05,prb	written.
*/

#ifndef	__INCcycleLibh
#define	__INCcycleLibh

#include <sys/cdefs.h>

#define	SET_RELOAD(x)
#undef	SET_RELOAD

typedef unsigned int CYCLE_TICK;
typedef unsigned long long int CYCLE_CLOCK;

typedef struct cycleLibEvent_t cycleLibEvent_t;
typedef cycleLibEvent_t *CEVENT_ID;

struct cycleLibEvent_t {
	CEVENT_ID	next;			/* Next event to fire */
	CEVENT_ID	prev;			/* doubly linked list */
	CYCLE_CLOCK	base;			/* time base if repeating */
	CYCLE_TICK	rate;			/* rate if repeating event */
	CYCLE_TICK	tick;			/* delta until event fires */
	void		(*callback)(void *);	/* callback function */
	void		*arg;			/* argument to callback */
};

__BEGIN_DECLS

extern void		cycleLibInit __P((void));
extern int		cycleLibPoolAlloc __P((int, CEVENT_ID));
extern void		cycleLibEventFree __P((CEVENT_ID));
extern void		cycleLibEventHandler __P((void));
extern CEVENT_ID	cycleLibEventAdd __P((CYCLE_TICK, void(*)(void *),
				void *));
extern CEVENT_ID	cycleLibEventAddRepeating __P((CYCLE_TICK,
				void(*)(void *), void *));
extern CEVENT_ID	cycleLibEventAddAbsolute __P((CYCLE_CLOCK,
				void(*)(void *), void *, CEVENT_ID));
extern void		cycleLibEventDelete __P((CEVENT_ID, void(*)(void *),
				void *));
__END_DECLS

/*
 * The values below should be set in a architecture specific location.
 */

#define	SET_TIMER(x)		vxDecSet(x)
#define	GET_CYCLE_CLOCK()	gettb()

__BEGIN_DECLS
extern CYCLE_CLOCK		gettb __P((void));
extern void			vxDecSet __P((unsigned));
__END_DECLS

#endif	/* __INCcycleLibh */
