/***********************************************************************************/
/*                        M-Systems Confidential                                   */
/*           Copyright (C) M-Systems Flash Disk Pioneers Ltd. 1995-2003            */
/*                         All Rights Reserved                                     */
/***********************************************************************************/
/*                            NOTICE OF M-SYSTEMS OEM                              */
/*                           SOFTWARE LICENSE AGREEMENT                            */
/*                                                                                 */
/*      THE USE OF THIS SOFTWARE IS GOVERNED BY A SEPARATE LICENSE                 */
/*      AGREEMENT BETWEEN THE OEM AND M-SYSTEMS. REFER TO THAT AGREEMENT           */
/*      FOR THE SPECIFIC TERMS AND CONDITIONS OF USE,                              */
/*      OR CONTACT M-SYSTEMS FOR LICENSE ASSISTANCE:                               */
/*      E-MAIL = info@m-sys.com                                                    */
/***********************************************************************************/

/*
 * $Log:   V:/PVCSDB/DiskOnChip/archives/Testing/TrueFFS 6.3/Drop 2.5/3/common/flfuncno.h-arc  $
 * 
 *    Rev 1.4   Sep 12 2005 13:10:58   roneng
 * Add MCOTP IOCTL structs 
 * 
 *    Rev 1.3   Jun 07 2005 06:19:26   OriS
 * - Added FL_ABS_SECURE_DELETE (flSecureDelete).
 * 
 *    Rev 1.2   Apr 19 2005 02:56:14   oris
 * - Added FL_RECOVER_FROM_POWER_LOSS for flRecoverFromPowerLoss()
 * 
 *    Rev 1.1   Apr 04 2005 20:18:00   oris
 * - Added function type : FL_HW_CONFIG
 * 
 *    Rev 1.0   Mar 27 2005 09:27:26   oris
 * Initial revision.
 * 
 *    Rev 1.4   Mar 07 2005 22:11:18   oris
 * -	Split FL_ERASE_BD to FL_ERASE_BD (erase single partition) and BD_UNFORMAT (unformat then entire media).
 * 
 *    Rev 1.3   Feb 19 2005 12:32:16   eugen
 * added FL_FLUSH_ALL_FILES command
 * 
 *    Rev 1.2   Feb 01 2005 09:33:28   eugen
 * uncommented INDEX_WRITE_FILE_START to restore command numbers
 * 
 *    Rev 1.1   Jan 05 2005 20:55:54   eugen
 * Commentaries, headers
 * 
 *    Rev 1.0   Dec 09 2004 18:23:44   oris
 * Initial revision.
 *    Rev 1.4   Jan 14 2004 22:31:46   oris
 * Added new API for closing all files and lowering the global attention flag.
 * 
 *    Rev 1.3   Sep 30 2003 17:58:32   oris
 * Added FL_FLUSH_FILE routine type.
 * 
 *    Rev 1.2   May 11 2003 08:27:28   OriS
 * Added  FL_WRITE_QUICK_MOUNT_INFO.
 * 
 *    Rev 1.1   May 08 2003 23:14:56   OriS
 * Added get quick mount state routine.
 * 
 *    Rev 1.0   Apr 09 2003 12:16:00   OriS
 * Initial revision.
 * 
 */

#ifndef FLFUNCNO_H
#define FLFUNCNO_H

/*************************************************************************************/
/* SPECIAL NOTE                                                                      */
/* ------------                                                                      */
/* The order of the enum bellow should be strictly kept since the bdcall function    */
/* utilizes the index values to simplify the function search                         */
/*************************************************************************************/

typedef enum {

/* The following routines are files related routines */

        /*********/
        /* FILES */
        /*********/

  FL_READ_FILE                  = 0,
  FL_WRITE_FILE,
  FL_SPLIT_FILE,
  FL_JOIN_FILE,
  FL_SEEK_FILE,
  FL_FIND_NEXT_FILE,
  FL_FIND_FILE,
  FL_TRUNCATE_FILE,
  INDEX_WRITE_FILE_START        = 100,
  FL_CLOSE_FILE,
  FL_FLUSH_FILE,
  INDEX_OPENFILES_END           = 200,
  FL_OPEN_FILE,
  FL_DELETE_FILE,
  FL_FIND_FIRST_FILE,
  FL_GET_DISK_INFO,
  FL_RENAME_FILE,
  FL_MAKE_DIR,
  FL_REMOVE_DIR,
  FL_FLUSH_BUFFER,
  FL_CLOSE_ALL_FILES,
  FL_FLUSH_ALL_FILES,
  FL_OPEN_DIRECTORY,
  FL_OPEN_MM_FILE,
  FL_LAST_FAT_FUNCTION          = 300,

/* The following routines will not perform valid partition check */

       /**********/
       /* BINARY */
       /**********/

  INDEX_BINARY_START            = 400,
  FL_BINARY_WRITE_INIT,
  FL_BINARY_WRITE_BLOCK,
  FL_BINARY_CREATE,
  FL_BINARY_ERASE,
  FL_BINARY_PROTECTION_CHANGE_KEY,
  FL_BINARY_PROTECTION_CHANGE_LOCK,
  FL_BINARY_PROTECTION_SET_TYPE,
  INDEX_BINARY_WRITE_END        = 500,
  FL_BINARY_READ_INIT,
  FL_BINARY_READ_BLOCK,
  FL_BINARY_PARTITION_INFO,
  FL_BINARY_PROTECTION_GET_TYPE,
  FL_BINARY_PROTECTION_INSERT_KEY,
  FL_BINARY_PROTECTION_REMOVE_KEY,
  INDEX_BINARY_END              = 600,

/* The following routines must be called with partition number 0 */

  INDEX_NEED_PARTITION_0_START  = 700,
      /* OTP */
  FL_OTP_SIZE,
  FL_OTP_READ,
  FL_OTP_WRITE,
  FL_WRITE_IPL,
  FL_READ_IPL,
      /* PHYSICAL */
  FL_DEEP_POWER_DOWN_MODE,
  FL_GET_PHYSICAL_INFO,
  FL_PHYSICAL_READ,
  FL_PHYSICAL_WRITE,
  FL_PHYSICAL_ERASE,
  FL_UPDATE_SOCKET_PARAMS,
  FL_UNIQUE_ID,
  FL_CUSTOMER_ID,
  BD_FORMAT_VOLUME,
  BD_FORMAT_PHYSICAL_DRIVE,
  FL_PLACE_EXB,
  FL_READ_BBT,
  FL_WRITE_BBT,
  FL_GET_EXTENDED_DISK_INFO,
  FL_PROTECTION_STICKY_LOCK,
  BD_FLASH_FORMAT,
  BD_UNFORMAT,
  FL_HW_CONFIG,
  FL_RECOVER_FROM_POWER_LOSS,

  INDEX_NEED_PARTITION_0_END    = 800,

/* The following routines will go through the volume validity check */

      /* PROTECTION */
  FL_PROTECTION_GET_TYPE,
  FL_PROTECTION_REMOVE_KEY,
  FL_PROTECTION_INSERT_KEY,
  FL_PROTECTION_SET_LOCK,
  FL_PROTECTION_CHANGE_KEY,
  FL_PROTECTION_CHANGE_TYPE,
  FL_COUNT_VOLUMES,
  FL_INQUIRE_CAPABILITIES,
     /* BDTL */
  FL_MOUNT_VOLUME,
  FL_ABS_MOUNT,
  BD_FORMAT_LOGICAL_DRIVE,
  FL_WRITE_PROTECTION,
  FL_DISMOUNT_VOLUME,
  FL_CHECK_VOLUME,
  FL_DEFRAGMENT_VOLUME,
  FL_ABS_WRITE,
  FL_ABS_DELETE,
  FL_ABS_READ,
  FL_ABS_ADDRESS,
  FL_GET_BPB,
  FL_SECTORS_IN_VOLUME,
  FL_VOLUME_INFO,
  FL_VERIFY_VOLUME,
  FL_CLEAR_QUICK_MOUNT_INFO,
  FL_RUGGEDIZE_OPERATION,	/* not used */
  FL_ABS_WRITE_UNCOMMITED,	/* not used */
  FL_ABS_DELETE_UNCOMMITED,	/* not used */
  FL_ABS_READ_RUGGEDIZED,	/* not used */
  FL_GET_QUICK_MOUNT_STATUS,
  FL_WRITE_QUICK_MOUNT_INFO,
  FL_LOAD_VOLUMES_CACHE,
  FL_COMPLETE_OPERATION,
  FL_FIND_LOGICAL_PARTITION,
  FL_CREATE_LOGICAL_PARTITIONS,
  FL_FORMAT_FS,
  FL_GET_BD_VERSION,
  FL_GET_FS_VERSION,
  BD_ERASE_BD,
  FL_ABS_SECURE_DELETE,
  FL_MCOTP_SIZE,
  FL_MCOTP_READ,
  FL_MCOTP_WRITE
} FLFunctionNo;


#endif /* FLFUNCNO_H */
