/***********************************************************************************/
/*                        M-Systems Confidential                                   */
/*           Copyright (C) M-Systems Flash Disk Pioneers Ltd. 1995-2006            */
/*                         All Rights Reserved                                     */
/***********************************************************************************/
/*                            NOTICE OF M-SYSTEMS OEM                              */
/*                           SOFTWARE LICENSE AGREEMENT                            */
/*                                                                                 */
/*      THE USE OF THIS SOFTWARE IS GOVERNED BY A SEPARATE LICENSE                 */
/*      AGREEMENT BETWEEN THE OEM AND M-SYSTEMS. REFER TO THAT AGREEMENT           */
/*      FOR THE SPECIFIC TERMS AND CONDITIONS OF USE,                              */
/*      OR CONTACT M-SYSTEMS FOR LICENSE ASSISTANCE:                               */
/*      E-MAIL = info@m-sys.com                                                    */
/***********************************************************************************/

/*
 * $Log:   V:/PVCSDB/DiskOnChip/archives/Testing/TrueFFS 6.3/Drop 2.5/3/common/flmalloc.h-arc  $
 * 
 *    Rev 1.7   May 17 2006 20:39:38   polina.marimont
 * flcommon.h changed to _common.h
 * 
 *    Rev 1.6   Feb 14 2006 11:05:16   DoronC
 * Update copyright note.
 * 
 *    Rev 1.5   Nov 13 2005 10:24:46   DoronC
 * Change header files to have external headers for binary release.
 * 
 *    Rev 1.4   Jul 06 2005 23:37:54   OriS
 * Added declaration of flInitTFFSMalloc() initialization routine.
 * 
 *    Rev 1.3   Jun 07 2005 06:20:26   OriS
 * - Esthetics - Make sure FL_HEAP_WALK is defined if either FL_DISPLAY_HEAP
 *   or FL_REPORT_BIGGEST_MEMCHUNK are defined.
 * - Esthetics - Moved default customization for flHeapPrint to the C file.
 * 
 *    Rev 1.2   Apr 21 2005 15:50:46   oris
 * Added include directive to flsystyp.h and placed the debug print under compilation flag.
 * 
 *    Rev 1.1   Apr 19 2005 02:57:24   oris
 * - Prevent dual include.
 * 
 *    Rev 1.0   Mar 27 2005 09:27:26   oris
 * Initial revision.
 * 
 *    Rev 1.1   Jan 05 2005 20:55:56   eugen
 * Commentaries, headers
 * 
 */
#ifndef _FL_MALLOC
#define _FL_MALLOC

#include "_common.h" /* For basic function types */

/* ------------------------------------------------------------------------- */
typedef struct {
FLDword flBackOffset;
FLDword flSize;
FLDword flFree;		/* these two could be bytes, or ints */
FLDword flLastBlock;	/* but we want the returned memory to be aligned to dword */
} flMemChunk;
/* ------------------------------------------------------------------------- */

void flInitTFFSMalloc(void); 
void * flMalloc(FLDword Length);
FLBoolean flFree(void * ChunkToDelete);
FLDword flTotalMemoryLeft(void);

#ifdef FL_DISPLAY_HEAP
#ifndef FL_HEAP_WALK
#define FL_HEAP_WALK
#endif	/* FL_HEAP_WALK */
FLBoolean flDisplayHeap(void);
#endif	/* FL_DISPLAY_HEAP */

#ifdef FL_REPORT_BIGGEST_MEMCHUNK
#ifndef FL_HEAP_WALK
#define FL_HEAP_WALK
#endif	/* FL_HEAP_WALK */
FLDword flBiggestFreeMemoryChunk(void);
#endif	/* FL_REPORT_BIGGEST_flMemChunk */

#ifdef FL_HEAP_WALK
typedef void (*flInpectHeapFunction)(flMemChunk *, void * extraInfo);
FLBoolean flHeapWalk(flInpectHeapFunction, void * extraInfo);
#define flHeapChk() flHeapWalk(NULL, NULL)
#endif	/* FL_HEAP_WALK */

/* ------------------------------------------------------------------------- */
#endif /*_FL_MALLOC*/


