/***********************************************************************************/
/*                        M-Systems Confidential                                   */
/*           Copyright (C) M-Systems Flash Disk Pioneers Ltd. 1995-2006            */
/*                         All Rights Reserved                                     */
/***********************************************************************************/
/*                            NOTICE OF M-SYSTEMS OEM                              */
/*                           SOFTWARE LICENSE AGREEMENT                            */
/*                                                                                 */
/*      THE USE OF THIS SOFTWARE IS GOVERNED BY A SEPARATE LICENSE                 */
/*      AGREEMENT BETWEEN THE OEM AND M-SYSTEMS. REFER TO THAT AGREEMENT           */
/*      FOR THE SPECIFIC TERMS AND CONDITIONS OF USE,                              */
/*      OR CONTACT M-SYSTEMS FOR LICENSE ASSISTANCE:                               */
/*      E-MAIL = info@m-sys.com                                                    */
/***********************************************************************************/

/*
 * $Log:   & 
 */

/*****************************************************************************
* File Header                                                                *
* -----------                                                                *
* Name : flsystyp.h                                                          *
*                                                                            *
* Description : System defintions and types required for the implementation  *
*              of the system customization routines.                         *
*                                                                            *
*****************************************************************************/

#ifndef FLSYSTYPE_H
#define FLSYSTYPE_H


#include "_common.h"
#include "flsystem.h"

/* Boolean constants */
#ifndef FALSE
#define FALSE    0
#endif /* FALSE */
#ifndef TRUE
#define TRUE     1
#endif /* TRUE */


/* Zones for debug printing */

#define FLZONE_NONE       0
#define FLZONE_MTD        0x0001
#define FLZONE_BDK        0x0002
#define FLZONE_TL         0x0004
#define FLZONE_BLKDEV     0x0008
#define FLZONE_FORMAT     0x0010
#define FLZONE_FS         0x0020
#define FLZONE_SOCKET     0x0040
#define FLZONE_IOCTL      0x0080
#define FLZONE_PROD       0x0100
#define FLZONE_STATISTICS 0x0200
#define FLZONE_UTIL       0x0400
#define FLZONE_PARA       0x0800
#define FLZONE_ABS        0x1000
#define FLZONE_ATA        0x2000
#define FLZONE_API        0x4000
#define FLZONE_FULL       0xffff

#endif /* FLSYSTYPE_H */
