/***********************************************************************************/
/*                        M-Systems Confidential                                   */
/*           Copyright (C) M-Systems Flash Disk Pioneers Ltd. 1995-2006            */
/*                         All Rights Reserved                                     */
/***********************************************************************************/
/*                            NOTICE OF M-SYSTEMS OEM                              */
/*                           SOFTWARE LICENSE AGREEMENT                            */
/*                                                                                 */
/*      THE USE OF THIS SOFTWARE IS GOVERNED BY A SEPARATE LICENSE                 */
/*      AGREEMENT BETWEEN THE OEM AND M-SYSTEMS. REFER TO THAT AGREEMENT           */
/*      FOR THE SPECIFIC TERMS AND CONDITIONS OF USE,                              */
/*      OR CONTACT M-SYSTEMS FOR LICENSE ASSISTANCE:                               */
/*      E-MAIL = info@m-sys.com                                                    */
/***********************************************************************************/

/*
 * $Log:   V:/PVCSDB/DiskOnChip/archives/Testing/TrueFFS 6.3/Drop 2.5/3/common/fltl.h-arc  $
 * 
 *    Rev 1.6   Apr 30 2006 10:22:20   Benoit.Seligmann
 * v1.3.1
 * 
 *    Rev 1.5   Feb 14 2006 11:05:18   DoronC
 * Update copyright note.
 * 
 *    Rev 1.4   Dec 05 2005 11:24:08   DoronC
 * Fix compilation errors & warnings under GNU compiler.
 * 
 *    Rev 1.3   Nov 13 2005 10:40:20   DoronC
 * Change header files to have external headers for binary release.
 * 
 *    Rev 1.2   Jun 07 2005 06:21:58   OriS
 * - Added the following fields to extended info routine:
 *   o dwType             - Flash type
 *   o dwSubType       - Flash Sub type
 *   o bMediaType       - Controller family
 * 
 * 
 *    Rev 1.1   Apr 19 2005 02:58:08   oris
 * - Cosmetics.
 * 
 *    Rev 1.0   Mar 27 2005 09:27:26   oris
 * Initial revision.
 * 
 */

#ifndef FLTL_H
#define FLTL_H

#include "flbase.h"
#include "flstruct.h"


typedef struct tTL TL;

/*----------------------------------------------------------*/
/* Format Parameters record passed to the translation layer */
/*----------------------------------------------------------*/

typedef struct {

  /* Global device info */

  FLByte             percentUse;

  FLByte             noOfBDTLPartitions;

  FLByte             noOfBinaryPartitions;

  BDTLPartitionFormatParams3   FAR2* BDTLPartitionInfo;

  BinaryPartitionFormatParams3 FAR2* binaryPartitionInfo;

  FLDword            flags;

  /* First volume info */

  FLByte             protectionKey[8];

  FLByte             protectionType;

  FLByte             noOfSpareUnits;

  /* Special features */

  FLByte             cascadedDeviceNo;

  FLByte             noOfCascadedDevices;

  FLProgressCallback progressCallback;

  FLDword            osakVersion;

  /* None DiskOnChip parameters */

  FLSDword           bootImageLen;

  FLSDword           dataPartitionLen;

  FLDword            vmAddressingLimit;

  FLWord             embeddedCISlength;

  FLByte FAR1 *      embeddedCIS;

} TLFormatParams;

#include "_fltl.h"

#endif /* FLTL_H */


