/***********************************************************************************/
/*                        M-Systems Confidential                                   */
/*           Copyright (C) M-Systems Flash Disk Pioneers Ltd. 1995-2006            */
/*                         All Rights Reserved                                     */
/***********************************************************************************/
/*                            NOTICE OF M-SYSTEMS OEM                              */
/*                           SOFTWARE LICENSE AGREEMENT                            */
/*                                                                                 */
/*      THE USE OF THIS SOFTWARE IS GOVERNED BY A SEPARATE LICENSE                 */
/*      AGREEMENT BETWEEN THE OEM AND M-SYSTEMS. REFER TO THAT AGREEMENT           */
/*      FOR THE SPECIFIC TERMS AND CONDITIONS OF USE,                              */
/*      OR CONTACT M-SYSTEMS FOR LICENSE ASSISTANCE:                               */
/*      E-MAIL = info@m-sys.com                                                    */
/***********************************************************************************/

/*
 * $Log:   V:/PVCSDB/DiskOnChip/archives/Testing/TrueFFS 6.3/Drop 2.5/3/bddoc/src/mtdsa.h-arc  $
 * 
 *    Rev 1.3   Feb 14 2006 11:09:48   DoronC
 * Update copyright note.
 * 
 *    Rev 1.2   Nov 13 2005 10:40:24   DoronC
 * Change header files to have external headers for binary release.
 * 
 *    Rev 1.1   Apr 04 2005 20:17:04   oris
 * - Compilation errors.
 * 
 *    Rev 1.0   Mar 27 2005 09:27:20   oris
 * Initial revision.
 * 
 *    Rev 1.0   Dec 09 2004 18:24:32   oris
 * Initial revision.
 * 
 *    Rev 1.1   Sep 01 2003 19:05:44   oris
 * - Changed noOfSockets to int instead of FLByte - removed compilation warnings.
 * - changed MTDS definition to FL_MTDS
 * 
 *    Rev 1.0   Apr 09 2003 12:16:00   OriS
 * Initial revision.
 * 
 */

/************************************************************************/
/* TrueFFS and Standalone MTD                                           */
/************************************************************************/

/************************************************************************/
/* File Header                                                          */
/* -----------                                                          */
/* Name : mtdsa.h                                                       */
/*                                                                      */
/* Description : This file contains neccesary definition and            */
/*                 customization                                        */
/*               for the MTD standalone mode. It also contains the      */
/*               compilation flag determining the mode of operation     */
/*                 either                                               */
/*               TrueFFS or MTD standalone                              */
/*                                                                      */
/* Warning :     TrueFFS application must keep the MTD_STANDALONE       */ 
/*                 definition                                           */
/*               commented.                                             */
/*                                                                      */
/************************************************************************/


#ifndef MTD_SA_H
#define MTD_SA_H


/************************************************************************/
/*                                                                      */
/*       Binary Development Kit Stand Alone Customization Area          */
/*                                                                      */
/************************************************************************/

typedef FLStatus (*SOCKETidentifyRoutine) (FLSocket * ,
          FLDword lowAddress, FLDword highAddress);
typedef void     (*FREEmtd) (FLSocket * pVol);

extern FLStatus flRegisterComponents(void);
extern void flSetWindowSize(FLSocket * socketPtr, unsigned sizeIn4KBunits);

extern FLBuffer    MTDSABuffer ;
#ifdef FL_VERIFY_WRITE
extern FLByte      MTDSAReadBackBuffer[1024];
#define flReadBackBufferOf(socket)   (&(MTDSAReadBackBuffer[0]));
#endif /* FL_VERIFY_WRITE */
extern FLSocket   MTDSASocket; /* socket record for the stand alone version  */
extern MTDidentifyRoutine    mtdTable   [FL_MTDS];
extern FLByte noOfSockets;
#ifdef MTD_STANDALONE
#define flSocketNoOf(socket)         0 /* currently we support only a single device */
#define flBufferOf(socket)           &MTDSABuffer
#define flSocketOf(socket)           &MTDSASocket
#endif /*MTD_STANDALONE*/
#define docSocketInit(socket)

#ifdef FL_ENVIRONMENT_VARS
extern FLByte flUse8Bit;
#endif /* FL_ENVIRONMENT_VARS */

#endif /* MTD_SA_H */
