#ifndef TIMERCORE_H
#define TIMERCORE_H

enum {
	kSetExternalEngineInt0ISRCallback,
	kSetExternalEngineReadGlobalTimeCallback,
	kEnableExternalEngine,
	kGetTimerISRCoreProc,
	kSetExternalEngineSetGlobalTimeCallback,
	kGetTimeAsNSSince1904,
	kSetTimeAsNSSince1904,
	kGetLegacyTickTimerPeriodEnabled,
	kDisableUserSetTime,
	kEnableUserSetTime,
	kSetExternalEngineReadLocalTimeCallback,
};

typedef void (*tReadTimeCallback)(long long* time);
typedef void (*tSetTimeCallback)(const long long* newTime);

extern unsigned long gExternalEngineEnabled;
extern tReadTimeCallback gExternalEngineReadLocalTimeCallback;
extern tReadTimeCallback gExternalEngineReadGlobalTimeCallback;
extern tSetTimeCallback gExternalEngineSetGlobalTimeCallback;
extern int gUserSetTimeEnabled;

void convertNSToUnix(long long, struct timespec*);
void convertNSFromUnix(struct timespec*, long long*);

void setTime(int64);
void initTimerCore(struct tm*);

int isDateTimeValid(struct tm*);
void setDefaultDateTime(struct tm*);

#endif
