/**
   \file        dipSwitches.h
   \author      Charles Crain
   \date        02/15/2005
   
   Handling for cRIO-9012 dip switches.

   COPYRIGHT 2005. NATIONAL INSTRUMENTS. ALL RIGHTS RESERVED.
*/

#ifndef ___dipSwitches_h___
#define ___dipSwitches_h___

#ifdef __cplusplus
extern "C" {
#endif

/**
   Initializes the GPIO lines to the system DIP switches.
*/
void dipSwitchInit();

/**   
   Returns nonzero if the serial redirect DIP switch is on, zero if off.
*/
int dipSwitchIsSerialRedirect();

/**
   Returns nonzero if the safe mode DIP switch is on, zero if off.
*/   
int dipSwitchIsSafeMode();

#ifdef __cplusplus
}
#endif
    
#endif /* ___dipSwitches_h___ */
