/* moduleHookLibP.h - private module hook facility header */

/*
 * Copyright (c) 2006 Wind River Systems, Inc.
 *
 * The right to copy, distribute, modify or otherwise make use of this software
 * may be licensed only pursuant to the terms of an applicable Wind River
 * license agreement.
 */

/*
modification history
--------------------
01b,26jan06,v_r  Fixed build warning.
01a,16jan06,v_r  Written.
*/

#ifndef __INCmoduleHookLibPh
#define __INCmoduleHookLibPh

#ifdef __cplusplus
extern "C" {
#endif

/* includes */

#ifdef HOST
#include <host.h>
#else
#include <vxWorks.h>
#include <limits.h>
#endif	/* HOST */

#include <sllLib.h>
#include <semLib.h>
#include <moduleLib.h>

/* Typedefs */

typedef struct moduleHookListStruct	/* module hook list structure */
    {
    SL_LIST moduleLoadHookList;		/* list of loader hooks */
    SL_LIST moduleUnloadHookList;	/* list of unloader hooks */
    SEM_ID  moduleHookListSem;		/* hook lists protection */
    } MOD_HKLST_STRUCT;

typedef MOD_HKLST_STRUCT * MOD_HKLST_STRUCT_ID;

typedef struct
    {
    SL_NODE node;   /* node for the linked list */
    FUNCPTR func;   /* associated routine */
    } MOD_HKLST_HOOK;

/* Defines */

/* Function declarations */

extern STATUS	moduleLoadHookAdd	(FUNCPTR moduleLoadHookRtn);
extern STATUS	moduleLoadHookDelete	(FUNCPTR moduleLoadHookRtn);
extern STATUS	moduleUnloadHookAdd	(FUNCPTR moduleUnloadHookRtn);
extern STATUS	moduleUnloadHookDelete	(FUNCPTR moduleUnloadHookRtn);

#ifdef __cplusplus
}
#endif

#endif /* __INCmoduleHookListPh */

