/* pgPoolPhysLibP.h - physical page pool object library header file */

/* 
 * Copyright (c) 2003-2005 Wind River Systems, Inc. 
 *
 * The right to copy, distribute, modify or otherwise make use 
 * of this software may be licensed only pursuant to the terms 
 * of an applicable Wind River license agreement. 
 */ 

/*
modification history
--------------------
01d,21jul05,zl   updated pgPoolLib API
01c,13sep04,zl   converted to private header file
01b,30nov03,yp   adding error code for address out of range
01a,08jul03,yp   written.
*/

#ifndef __INCpgPoolPhysLibPh
#define __INCpgPoolPhysLibPh

#ifdef __cplusplus
extern "C" {
#endif

/* includes */

#include <vxWorks.h>
#include <private/pgPoolLibP.h>


#ifndef	_ASMLANGUAGE

/* function declarations */

extern STATUS	 pgPoolPhysLibInit (void);
extern STATUS	 pgPoolPhysAddToPool (PAGE_POOL_ID poolId, PHYS_ADDR addr, 
				      UINT numPages, UINT state);
extern STATUS	 pgPoolPhysRemoveFromPool (PAGE_POOL_ID poolId, PHYS_ADDR addr,
					   UINT numPages);
extern PHYS_ADDR pgPoolPhysAlloc (PAGE_POOL_ID poolId, UINT numPages);
extern PHYS_ADDR pgPoolPhysAlignedAlloc (PAGE_POOL_ID poolId, UINT numPages,
					 UINT alignment);
extern PHYS_ADDR pgPoolPhysAllocAt (PAGE_POOL_ID poolId, PHYS_ADDR startAddr,
				    UINT numPages);
extern PHYS_ADDR pgPoolPhysAvailAlloc (PAGE_POOL_ID poolId, UINT * pNumPages);
extern STATUS	 pgPoolPhysFree (PAGE_POOL_ID poolId, PHYS_ADDR startAddr,
				 UINT numPages);
extern BOOL	 pgPoolPhysRangeIsFree (PAGE_POOL_ID poolId, PHYS_ADDR startAddr,
				        UINT numPages);
extern BOOL	 pgPoolPhysRangeIsAllocated (PAGE_POOL_ID poolId,
					     PHYS_ADDR startAddr,
					     UINT numPages);
extern BOOL	 pgPoolPhysRangeVerify (PAGE_POOL_ID poolId,
					PHYS_ADDR pageAddr, UINT numPages);
extern STATUS	 pgPoolPhysNextFreeGet (PAGE_POOL_ID poolId, PHYS_ADDR refAddr,
					PHYS_ADDR * pFreeAddr, 
					UINT * pNumPages);
extern STATUS	 pgPoolPhysRangeEach (PAGE_POOL_ID poolId, UINT state,
				      FUNCPTR usrRtn, void * pArg);


#endif	/* _ASMLANGUAGE */

#ifdef __cplusplus
}
#endif

#endif /* __INCpgPoolPhysLibPh */
