/* pgPoolVirtLibP.h - virtual page pool object library header file */

/* 
 * Copyright (c) 2003-2005 Wind River Systems, Inc. 
 *
 * The right to copy, distribute, modify or otherwise make use 
 * of this software may be licensed only pursuant to the terms 
 * of an applicable Wind River license agreement. 
 */ 

/*
modification history
--------------------
01c,21jul05,zl   updated pgPoolLib API
01b,13sep04,zl   converted to private header file.
01a,08jul03,yp   written.
*/

#ifndef __INCpgPoolVirtLibPh
#define __INCpgPoolVirtLibPh

#ifdef __cplusplus
extern "C" {
#endif

/* includes */

#include <vxWorks.h>
#include <private/pgPoolLibP.h>


#ifndef	_ASMLANGUAGE


/* function declarations */

extern STATUS	 pgPoolVirtLibInit (void);
extern STATUS	 pgPoolVirtAddToPool (PAGE_POOL_ID poolId, VIRT_ADDR addr,
				      UINT numPages, UINT state);
extern STATUS	 pgPoolVirtRemoveFromPool (PAGE_POOL_ID poolId, VIRT_ADDR addr,
					   UINT numPages);
extern VIRT_ADDR pgPoolVirtAlloc (PAGE_POOL_ID poolId, UINT numPages);
extern VIRT_ADDR pgPoolVirtAlignedAlloc (PAGE_POOL_ID poolId, UINT numPages,
					 UINT alignment);
extern VIRT_ADDR pgPoolVirtAllocAt (PAGE_POOL_ID poolId, VIRT_ADDR startAddr,
				    UINT numPages);
extern VIRT_ADDR pgPoolVirtAvailAlloc (PAGE_POOL_ID poolId, UINT * pNumPages);
extern STATUS	 pgPoolVirtFree (PAGE_POOL_ID poolId, VIRT_ADDR startAddr,
				 UINT numPages);
extern BOOL	 pgPoolVirtRangeIsFree (PAGE_POOL_ID poolId, VIRT_ADDR startAddr,
					UINT numPages);
extern BOOL	 pgPoolVirtRangeIsAllocated (PAGE_POOL_ID poolId,
					     VIRT_ADDR startAddr, 
					     UINT numPages);
extern BOOL	 pgPoolVirtRangeVerify (PAGE_POOL_ID poolId,
					VIRT_ADDR startAddr, UINT numPages);
extern STATUS	 pgPoolVirtNextFreeGet (PAGE_POOL_ID poolId, VIRT_ADDR addr, 
					VIRT_ADDR * pFreeAddr, UINT * pNumPages);
extern STATUS	 pgPoolVirtRangeEach (PAGE_POOL_ID poolId, UINT state,
				      FUNCPTR usrRtn, void * pArg);

#endif	/* _ASMLANGUAGE */

#ifdef __cplusplus
}
#endif

#endif /* __INCpgPoolVirtLibPh */
