/* pxCpuTimeLibP.h - header for POSIX thread CPU-time library */

/*
 * Copyright (c) 2006 Wind River Systems, Inc.
 *
 * The right to copy, distribute, modify or otherwise make use
 * of this software may be licensed only pursuant to the terms
 * of an applicable Wind River license agreement.
 */

/*
modification history
--------------------
01b,22feb06,jln  replace the WDOG with PX_CPUTIMER
01a,25jan06,jln  Created
*/

#ifndef __INCpxCpuTimeLibPh
#define __INCpxCpuTimeLibPh

#ifdef __cplusplus
extern "C" {
#endif

#include <vxWorks.h>
#include <qLib.h>
#include <private/timerLibP.h>

/* defines */

#define PX_CPUTIMER_OUT_OF_Q   0x0     /* CPU-time node not in tick queue */
#define PX_CPUTIMER_IN_Q       0x1     /* CPU-time node in tick queue */

/* typedef */

/* NOTE: tickNode shall be the first, don't change the position */

typedef struct px_cputimer	/* low-level CPU-time timer structure */
    {
    Q_NODE      tickNode;       /* multi-way queue node for tick queue */
    USHORT      status;         /* status of node */
    timer_t     timerId;        /* high-level timer ID associated */
    } PX_CPUTIMER;

/* Function declarations */

extern void 	pxCpuTimeLibInit   (void);
extern PX_CPUTIMER * pxCpuTimerCreate (void);
extern STATUS   pxCpuTimerStart     (timer_t, int);
extern STATUS   pxCpuTimerCancel    (PX_CPUTIMER *, int);
extern STATUS   pxCpuTimerDelete    (PX_CPUTIMER *, int);

#ifdef __cplusplus
}
#endif

#endif /* __INCpxCpuTimeLibPh */
