/* scMemValP.h - private header file for system call validation routines */

/* 
 * Copyright (c) 1993-2005 Wind River Systems, Inc. 
 *
 * The right to copy, distribute, modify or otherwise make use 
 * of this software may be licensed only pursuant to the terms 
 * of an applicable Wind River license agreement. 
 */ 

/*
modification history
--------------------
01d,15dec05,zl   added scMemPrivValidate() prototype.
01c,05nov04,zl   moved function prototype to public header.
01b,19apr04,tam  updated prototype
01a,23oct03,tam  written.
*/

#ifndef __INCscMemValPh
#define __INCscMemValPh

#ifdef __cplusplus
extern "C" {
#endif

#include <scMemVal.h>


/* protection mask */

#define SC_PROT_MSK	(SC_PROT_READ | SC_PROT_WRITE)


#ifndef _ASMLANGUAGE

STATUS scMemPrivValidate (const void * addr, UINT size, SC_PROT_ATTR access,
			  RTP_ID rtpId);

#endif /* _ASMLANGUAGE */


#ifdef __cplusplus
}
#endif

#endif /* __INCscMemValPh */
