/* taskPxLibP.h - header for POSIX thread support in VxWorks task */

/*
 * Copyright (c) 2005-2006 Wind River Systems, Inc.
 *
 * The right to copy, distribute, modify or otherwise make use
 * of this software may be licensed only pursuant to the terms
 * of an applicable Wind River license agreement.
 */

/*
modification history
--------------------
01d,28feb06,jln  added taskPxAttrCreate()
01c,20jan06,jln  added TASK_PX_SCHED_INFO structure
01b,05aug05,jln  added taskPxWindTickAnnounceHook
01a,25jun05,jln  Created
*/

#ifndef __INCtaskPxLibPh
#define __INCtaskPxLibPh

#ifdef __cplusplus
extern "C" {
#endif

#include <private/taskLibP.h>
#include <private/taskPxLibCommonP.h>

/* typedef */

/* POSIX thread scheduling information */

typedef struct task_px_sched_info
     {
     UINT64     	execTick;       /* thread execution tick */
     Q_HEAD     	execTickQHead;  /* tick queue for CPU-time clock */
     UINT       	schedPolicy;    /* scheduling policy */
     } TASK_PX_SCHED_INFO;

/* Function declarations */

extern STATUS 		taskPxLibInit (void);
extern STATUS 		taskPxAttrSet (int tid, void * pAttr);
extern STATUS           taskPxAttrGet (int tid, void * pAttr);
extern STATUS 		taskPxAttrCreate (int tid, void * pAttr);
extern void		taskPxWindTickAnnounceHook (WIND_TCB *);
#ifdef __cplusplus
}
#endif

#endif /* __INCtaskPxLibPh */
