/* wvSockUploadPathLibP.h - socket upload path library header */

/* Copyright 1997 Wind River Systems, Inc. */

/*
modification history
--------------------
01f,04sep03,tcr  rename init function
01e,27jan98,cth  removed sockUploadPathError prototypes, SOSENDBUFSIZE, added
		 sockUpPathSendBufSize
01d,18dec97,cth  renamed again to wvSockUploadPathLibP.h from, updated include, 
		 wvSockUploadPathP.h, added sockUploadPathLibInit prototype
01c,16nov97,cth  renamed again from sockUploadPathP.h to wvSockUploadPathP.h
01b,16nov97,cth  changed prototypes to match WV2.0 upload-path model
                 renamed from evtSockLibP.h to sockUploadPathP.h
01a,10dec93,smb  written.
*/


#ifndef __INCwvsockuploadpathlibph
#define __INCwvsockuploadpathlibph

#ifdef __cplusplus
extern "C" {
#endif

#include "private/wvUploadPathP.h"


/* variable declarations */

extern int sockUpPathSendBufSize;


/* function declarations */

extern STATUS	    wvSockUploadPathLibInit (void);
extern UPLOAD_ID    wvSockUploadPathCreate (char *ipAddress, short port);
extern void         wvSockUploadPathClose (UPLOAD_ID upId);
extern int          wvSockUploadPathWrite (UPLOAD_ID upId, char * pData,
                                           size_t size);


#ifdef __cplusplus
}
#endif

#endif /* __INCwvsockuploadpathlibph*/

