/*---------------------------------------------------------------------------
               ----> DO NOT REMOVE THE FOLLOWING NOTICE <----

                  Copyright (c) 2003 - 2006 Datalight, Inc.
                    All Rights Reserved.  Patent Pending.

  Datalight, Incorporated is a Washington State corporation located at:

        21520 30th Dr SE, Suite 110,      Tel:  425-951-8086
        Bothell, WA  98021                Fax:  425-951-8094
        USA                               Http://www.datalight.com

  This software, including without limitation, all source code and documen-
  tation, is the confidential, trade secret property of Datalight, Inc., and
  is protected under the copyright laws of the United States and other juris-
  dictions.

  In addition to civil penalties for infringement of copyright under applic-
  able U.S. law, 17 U.S.C. 1204 provides criminal penalties for violation of
  (a) the restrictions on circumvention of copyright protection systems found
  in 17 U.S.C. 1201 and (b) the protections for the integrity of copyright
  management information found in 17 U.S.C. 1202.

  U.S. Government Restricted Rights:  Use, duplication, reproduction, or
  transfer of this commercial product and accompanying documentation is
  restricted in accordance with FAR 12.212 and DFARS 227.7202 and by a
  License Agreement.

  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS PROTECTED UNDER A
  SOURCE CODE AGREEMENT, NON-DISCLOSURE AGREEMENT (NDA), OR SIMILAR BINDING
  CONTRACT BETWEEN DATALIGHT, INC. AND THE LICENSEE ("BINDING AGREEMENT").
  YOUR RIGHT, IF ANY, TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,
  IS SUBJECT TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT.  BY USING
  THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE TO BE BOUND BY
  THE TERMS OF THE BINDING AGREEMENT.  CONTACT DATALIGHT, INC. AT THE ADDRESS
  SET FORTH ABOVE IF YOU OBTAINED THIS SOFTWARE IN ERROR.
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                                Description

    This is the master Reliance header that is included by all Reliance C
    code.

    Note that this file should typically be include after any ToolSet or OIL
    specific includes such as string.h or windows.h respectively.
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                                Revision History
    $Log: reliance.h $
    Revision 1.2  2006/01/04 03:25:06  Garyp
    Cosmetic changes only.
    Revision 1.1  2005/12/07 17:34:56Z  Pauli
    Initial revision
    Revision 1.3  2005/12/07 17:34:56Z  Garyp
    Updated to initialize TFS_DEBUG.
    Revision 1.2  2005/12/05 19:41:16Z  Pauli
    Merge with 2.0 product line, build 458.
    Revision 1.15  2005/06/24 00:36:49Z  brandont
    Made a common location to set the D_DEBUG define. Made a common
    location to set the TFS_DEBUG setting to D_DEBUG.  Added rlfsconf.h 
    to the common include list.
    Revision 1.14  2005/06/20 20:32:14Z  PaulI
    Removed rl64bit.h, it has been replaced in DCL.
    Revision 1.13  2005/06/14 18:32:22Z  PaulI
    Updated to include rltrace.h. Changed the definition of TRUE to 1 instead
    of (!FALSE) so that it will not conflict with NT.
    Revision 1.12  2005/06/03 20:16:24Z  brandont
    Renamed rltrace.h to rltrace2.h.
    Revision 1.11  2005/05/26 01:10:58Z  brandont
    Added rltrace.h, rlprof.h, and rlenter.h to the common include header file
    list.
    Revision 1.10  2005/04/13 01:31:43Z  brandont
    Revision 1.9  2005/04/13 01:31:43Z  brandont
    Added relver.h to the main includes.
    Revision 1.8  2005/03/23 19:52:23Z  GaryP
    Eliminated the inclusion of stdarg.h.
    Revision 1.7  2005/03/10 02:34:32Z  GaryP
    Updated to include dlapi.h rather than toolset.h.
    Revision 1.6  2005/02/28 21:11:49Z  brandont
    Added the rlbastyp.h include for the Reliance base types.
    Revision 1.5  2004/12/31 01:17:52Z  GaryP
    Updated to use indents of 4, hard tabs of 8 (if used), and a standard
    comment style.
    Revision 1.4  2004/12/01 02:46:12Z  brandont
    Added rlstdlib.h and rlmisc.h to the common header file list.
    Revision 1.3  2004/11/20 01:45:27Z  brandont
    Added rlosserv.h, rllog.h, rlerr.h, rlstring.h, rlstdio.h, and rlctype.h to
    the list of common includes.
    Revision 1.2  2004/10/01 21:36:32Z  brandont
    Added rl64bit.h to the master include list.
    Revision 1.1  2004/09/27 18:12:26  brandont
    Initial revision
---------------------------------------------------------------------------*/

#ifndef RELIANCE_H_INCLUDED
#define RELIANCE_H_INCLUDED


/*-------------------------------------------------------------------
    NOTE:  The product locale number must match the values found in
           the various prodinfo.bat files for each of the products
           (see dlprod.h for more information).
-------------------------------------------------------------------*/
#ifndef D_PRODUCTLOCALE
#define D_PRODUCTLOCALE     (1)     /* Reliance */
#endif


/*-------------------------------------------------------------------
    NOTE:  The TFS_DEBUG setting is deprecated.  Use D_DEBUG instead.
-------------------------------------------------------------------*/
#define TFS_DEBUG          D_DEBUG


/*  Note that the order in which these items are included is critical
*/
#include <dcl.h>
#include <relconf.h>

#include <rlver.h>
#include <rlfsconf.h>
#include <rlopts.h>
#include <rlbastyp.h>
#include <rltypes.h>
#include <rlmods.h>
#include <rlmacro.h>
#include <rloil.h>
#include <rlosserv.h>
#include <rllog.h>
#include <rlerr.h>
#include <rltrace.h>
#include <rltrace2.h>
#include <rlprof.h>
#include <rlenter.h>

#include <rlstring.h>
#include <rlstdio.h>
#include <rlstdlib.h>
#include <rlctype.h>



#define TFS_REPAIR 0

#endif /* RELIANCE_H_INCLUDED */
