/*---------------------------------------------------------------------------
               ----> DO NOT REMOVE THE FOLLOWING NOTICE <----

      Copyright (c) 2003 - 2004 Datalight, Inc.  All Rights Reserved.

  Datalight, Incorporated is a Washington State corporation located at:

        21520 30th Dr SE, Suite 110,      Tel:  425-951-8086
        Bothell, WA  98021                Fax:  425-951-8094
        USA                               Http://www.datalight.com

  This software, including without limitation, all source code and documen-
  tation, is the confidential, trade secret property of Datalight, Inc., and
  is protected under the copyright laws of the United States and other juris-
  dictions.

  ---> Portions of the software are patent pending <---

  In addition to civil penalties for infringement of copyright under applic-
  able U.S. law, 17 U.S.C. 1204 provides criminal penalties for violation of
  (a) the restrictions on circumvention of copyright protection systems found
  in 17 U.S.C. 1201 and (b) the protections for the integrity of copyright
  management information found in 17 U.S.C. 1202.

  U.S. Government Restricted Rights:  Use, duplication, reproduction, or
  transfer of this commercial product and accompanying documentation is
  restricted in accordance with FAR 12.212 and DFARS 227.7202 and by a
  License Agreement.

  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS PROTECTED UNDER A
  SOURCE CODE AGREEMENT, NON-DISCLOSURE AGREEMENT (NDA), OR SIMILAR BINDING
  CONTRACT BETWEEN DATALIGHT, INC. AND THE LICENSEE ("BINDING AGREEMENT").
  YOUR RIGHT, IF ANY, TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,
  IS SUBJECT TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT.  BY USING
  THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE TO BE BOUND BY
  THE TERMS OF THE BINDING AGREEMENT.  CONTACT DATALIGHT, INC. AT THE ADDRESS
  SET FORTH ABOVE IF YOU OBTAINED THIS SOFTWARE IN ERROR.
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Description
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Revision History
    $Log: rlbucket.h $
    Revision 1.1  2005/07/19 01:06:22  Pauli
    Initial revision
    Revision 1.2  2005/07/19 02:06:21Z  Pauli
    Merge with 2.0 product line, build 458.
    Revision 1.2  2005/07/19 02:06:21Z  brandont
    Added TFS_CORE_FindClose to the bucket enumeration.
    Revision 1.1  2005/02/23 02:34:58Z  brandont
    Initial revision
---------------------------------------------------------------------------*/

#ifndef __rlbucket_h
#define __rlbucket_h  1


/*  for use in determine # of calls to TfsCoreXxx
*/


/*  be sure to change string array in tfutest.c
*/
enum TfsCoreBucket
{
    TFS_CORE_Initialize = 0,
    TFS_CORE_Uninitialize,
    TFS_CORE_InitializeVolume,
    TFS_CORE_UninitializeVolume,
    TFS_CORE_Mount,
    TFS_CORE_Unmount,
    TFS_CORE_TransactionPoint,
    TFS_CORE_Ioctl,
    TFS_CORE_GetVolumeInfo,
    TFS_CORE_MakeDirectory,
    TFS_CORE_RemoveDirectory,
    TFS_CORE_OpenDirectory,
    TFS_CORE_ReadFromDirectory,
    TFS_CORE_RewindDirectory,
    TFS_CORE_CloseDirectory,
    TFS_CORE_FindFirst,
    TFS_CORE_FindNext,
    TFS_CORE_FindClose,
    TFS_CORE_MatchName,
    TFS_CORE_CreateFile,
    TFS_CORE_DeleteFile,
    TFS_CORE_Rename,
    TFS_CORE_OpenFile,
    TFS_CORE_ReadFromFile,
    TFS_CORE_WriteToFile,
    TFS_CORE_TruncateFile,
    TFS_CORE_CloseFile,
    TFS_CORE_AddHardLink,
    TFS_CORE_SetAttributes,
    TFS_CORE_GetAttributes,
    TFS_CORE_Exist,
    TFS_CORE_TotalCalls,
    TFS_CORE_NUMBUCKETS
};

/*  for use in determine # of calls to TfsIoXxx
*/

/*  be sure to change string array in tfutest.c
*/
enum TfsIoBucket
{
    TFS_IO_SetVolumeGeometry = 0,
    TFS_IO_GetVolumeGeometry,
    TFS_IO_DiscardBlocks,
    TFS_IO_Flush,
    TFS_IO_Verify,
    TFS_IO_Read,
    TFS_IO_Write,
    TFS_IO_RawRead,
    TFS_IO_RawWrite,
    TFS_IO_CacheHit,
    TFS_IO_CacheMiss,
    TFS_IO_TotalCalls,
    TFS_IO_NUMBUCKETS
};

/*  for IOCTL TFS_IOCTL_GET_BUCKETS
*/
struct TfsTagBucket
{
    tfsUint32       iCoreBucket[TFS_CORE_NUMBUCKETS];
};
typedef struct TfsTagBucket sTfsBucket;


#endif /* #ifndef __rlbucket_h */

