/*---------------------------------------------------------------------------
               ----> DO NOT REMOVE THE FOLLOWING NOTICE <----

      Copyright (c) 2003 - 2004 Datalight, Inc.  All Rights Reserved.

  Datalight, Incorporated is a Washington State corporation located at:

        21520 30th Dr SE, Suite 110,      Tel:  425-951-8086
        Bothell, WA  98021                Fax:  425-951-8094
        USA                               Http://www.datalight.com

  This software, including without limitation, all source code and documen-
  tation, is the confidential, trade secret property of Datalight, Inc., and
  is protected under the copyright laws of the United States and other juris-
  dictions.

  ---> Portions of the software are patent pending <---

  In addition to civil penalties for infringement of copyright under applic-
  able U.S. law, 17 U.S.C. 1204 provides criminal penalties for violation of
  (a) the restrictions on circumvention of copyright protection systems found
  in 17 U.S.C. 1201 and (b) the protections for the integrity of copyright
  management information found in 17 U.S.C. 1202.

  U.S. Government Restricted Rights:  Use, duplication, reproduction, or
  transfer of this commercial product and accompanying documentation is
  restricted in accordance with FAR 12.212 and DFARS 227.7202 and by a
  License Agreement.

  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS PROTECTED UNDER A
  SOURCE CODE AGREEMENT, NON-DISCLOSURE AGREEMENT (NDA), OR SIMILAR BINDING
  CONTRACT BETWEEN DATALIGHT, INC. AND THE LICENSEE ("BINDING AGREEMENT").
  YOUR RIGHT, IF ANY, TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,
  IS SUBJECT TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT.  BY USING
  THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE TO BE BOUND BY
  THE TERMS OF THE BINDING AGREEMENT.  CONTACT DATALIGHT, INC. AT THE ADDRESS
  SET FORTH ABOVE IF YOU OBTAINED THIS SOFTWARE IN ERROR.
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Description
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Revision History
    $Log: rlclib.h $
    Revision 1.1  2005/08/04 18:54:46  Pauli
    Initial revision
    Revision 1.2  2005/08/04 19:54:46Z  Pauli
    Merge with 2.0 product line, build 458.
    Revision 1.2  2005/08/04 19:54:46Z  brandont
    Updated the test interface for the checker.
    Revision 1.1  2005/02/18 01:35:34Z  brandont
    Initial revision
---------------------------------------------------------------------------*/

#ifndef __RLCLIB_H
#define __RLCLIB_H      1


/*  special types for use with TFS file functions
*/
#define TFSFILE void
#define TFSDIR void
#define TFSDIRENT void

/*  for test seek functions
*/
#define TFS_SEEK_SET 0
#define TFS_SEEK_CUR 1
#define TFS_SEEK_END 2

/*  TfsCLibFOpen read/write modes
*/
#define TFS_SZREAD_MODE    TfsStr("r+b")
#define TFS_SZWRITE_MODE   TfsStr("w+b")

/*  error # used by test suite, utils, BUT NOT OIL
*/
extern int      giTfsErrorNo;

/*  for the TfsCLibSaveDir function
*/
#define TFS_SAVEDIR_SAVE      TFS_TRUE
#define TFS_SAVEDIR_RESTORE      TFS_FALSE


/*  C Library file functions (for use by test suite, utils, BUT NOT OIL)
*/
TFSFILE        *TfsCLibFOpen(
    const tfsChar * szFileName,
    const tfsChar * szMode);
tfsOffset       TfsCLibFRead(
    tfsBuffer * pBuffer,
    tfsOffset iSize,
    tfsOffset iNumber,
    TFSFILE * fp);
tfsOffset       TfsCLibFWrite(
    tfsBuffer * pBuffer,
    tfsOffset iSize,
    tfsOffset iNumber,
    TFSFILE * fp);
tfsOffset       TfsCLibFTell(
    TFSFILE * fp);
int             TfsCLibFSeek(
    TFSFILE * fp,
    tfsOffset iOffset,
    int iWhence);
int             TfsCLibFClose(
    TFSFILE * fp);
int             TfsCLibRemove(
    const tfsChar * szFileName);
int             TfsCLibRename(
    const tfsChar * szOldName,
    const tfsChar * szNewName);
int             TfsCLibTruncate(
    const tfsChar * szFileName,
    tfsOffset iOffset);
int             TfsCLibMkDir(
    const tfsChar * szPath);
int             TfsCLibRmDir(
    const tfsChar * szPath);
TFSDIR         *TfsCLibOpenDir(
    const tfsChar * szPath);
TFSDIRENT      *TfsCLibReadDir(
    TFSDIR * pDir);
tfsChar        *TfsCLibGetDirName(
    TFSDIRENT * pDirEntry);
tfsBool         TfsCLibIsDir(
    TFSDIRENT * pDirEntry);
int             TfsCLibCloseDir(
    TFSDIR * pDir);
int             TfsCLibChDir(
    tfsChar * szPath,
    sTfsVolume * pVolume);
int             TfsCLibIoctl(
    int iCmd,
    void *pBuffer);
int             TfsCLibSaveDir(
    tfsBool fSave);
int             TfsCLibGetVolumeInfo(
    tfsBlock * piNumBlocks,
    tfsBlock * piBlockSize,
    tfsBlock * piFreeBlocks);
int             TfsCLibTransaction(
    void);
TFSERR TfsCLibFormatVolume(
    tfsChar * szVolume,
    tfsUint32 iBlockSize);
TFSERR TfsCLibCheckVolume(
    LogHandle * pLogHandle,
    tfsChar * pDevice,
    tfsBool fVerboseMode,
    tfsBool fNoConfirm,
    tfsBool fQuietMode,
    tfsBool fRepair,
    tfsBool fDumpIndex,
    tfsBool fShowProgress );


/*  C Library file functions to the native file system
*/
extern tfsChar  gszTfsFOpenReadBin[];
extern tfsChar  gszTfsFOpenRead[];
extern tfsChar  gszTfsFOpenReadWrite[];
extern tfsChar  gszTfsFOpenCreate[];
TFSFILE        *TfsNLibFOpen(
    const tfsChar * szFileName,
    const tfsChar * szMode);
int             TfsNLibFClose(
    TFSFILE * fp);
int             TfsNLibFFlush(
    TFSFILE * fp);
tfsOffset       TfsNLibFRead(
    tfsBuffer * pBuffer,
    tfsOffset iSize,
    tfsOffset iNumber,
    TFSFILE * fp);
tfsOffset       TfsNLibFWrite(
    tfsBuffer * pBuffer,
    tfsOffset iSize,
    tfsOffset iNumber,
    TFSFILE * fp);
int             TfsNLibFSeek(
    TFSFILE * fp,
    tfsOffset iOffset,
    int iWhence);
tfsOffset       TfsNLibFTell(
    TFSFILE * fp);
int             TfsNLibRemove(
    const tfsChar * szFileName);
tfsChar        *TfsNLibFGets(
    tfsChar * pBuffer,
    int iMaxLen,
    TFSFILE * fp);


/*  C Library directory functions to the native file system
*/
int             TfsNLibMkDir(
    const tfsChar * szPath);
int             TfsNLibRmDir(
    const tfsChar * szPath);
TFSDIR         *TfsNLibOpenDir(
    const tfsChar * szPath);
TFSDIRENT      *TfsNLibReadDir(
    TFSDIR * pDir);
tfsChar        *TfsNLibGetDirName(
    TFSDIRENT * pDirEntry);
tfsBool         TfsNLibIsDir(
    TFSDIRENT * pDirEntry);
int             TfsNLibCloseDir(
    TFSDIR * pDir);


#endif /* #ifndef __RLCLIB_H */
