/*---------------------------------------------------------------------------
               ----> DO NOT REMOVE THE FOLLOWING NOTICE <----

      Copyright (c) 2003 - 2005 Datalight, Inc.  All Rights Reserved.

  Datalight, Incorporated is a Washington State corporation located at:

        21520 30th Dr SE, Suite 110,      Tel:  425-951-8086
        Bothell, WA  98021                Fax:  425-951-8094
        USA                               Http://www.datalight.com

  This software, including without limitation, all source code and documen-
  tation, is the confidential, trade secret property of Datalight, Inc., and
  is protected under the copyright laws of the United States and other juris-
  dictions.

  ---> Portions of the software are patent pending <---

  In addition to civil penalties for infringement of copyright under applic-
  able U.S. law, 17 U.S.C. 1204 provides criminal penalties for violation of
  (a) the restrictions on circumvention of copyright protection systems found
  in 17 U.S.C. 1201 and (b) the protections for the integrity of copyright
  management information found in 17 U.S.C. 1202.

  U.S. Government Restricted Rights:  Use, duplication, reproduction, or
  transfer of this commercial product and accompanying documentation is
  restricted in accordance with FAR 12.212 and DFARS 227.7202 and by a
  License Agreement.

  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS PROTECTED UNDER A
  SOURCE CODE AGREEMENT, NON-DISCLOSURE AGREEMENT (NDA), OR SIMILAR BINDING
  CONTRACT BETWEEN DATALIGHT, INC. AND THE LICENSEE ("BINDING AGREEMENT").
  YOUR RIGHT, IF ANY, TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,
  IS SUBJECT TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT.  BY USING
  THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE TO BE BOUND BY
  THE TERMS OF THE BINDING AGREEMENT.  CONTACT DATALIGHT, INC. AT THE ADDRESS
  SET FORTH ABOVE IF YOU OBTAINED THIS SOFTWARE IN ERROR.
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Description
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Revision History
    $Log: rlenter.h $
    Revision 1.2  2006/01/26 00:39:05  brandont
    Merged with Reliance 2.0 code base.
    Revision 1.1  2006/01/03 04:22:00Z  brandont
    Gave static variables more unique names.
    $Log: rlenter.h $
    Revision 1.2  2006/01/26 00:39:05  brandont
    Merged with Reliance 2.0 code base.
    Revision 1.1  2005/08/01 17:35:36Z  Pauli
    Initial revision
    Revision 1.1  2005/08/01 18:35:36Z  Garyp
    Initial revision
    Revision 1.3  2005/08/01 18:35:36Z  pauli
    Updated macros to use new profiler enter which takes a ulUserData parameter.
    Revision 1.2  2005/07/31 01:49:45Z  Garyp
    Updated to use new profiler leave function which now takes a ulUserData
    parameter.
    Revision 1.1  2005/07/25 21:11:10Z  pauli
    Initial revision
---------------------------------------------------------------------------*/

#ifndef _RLENTER_H
#define _RLENTER_H   1

#if DCLCONF_PROFILERENABLED

#define RelEnter(_szLabel)  DclProfilerEnter(_szLabel, 0, 0)
#define RelLeave()          DclProfilerLeave(0UL)

#else

#define RelEnter(_szLabel)
#define RelLeave()

#endif


#if 0
#if TFS_TRACE_ENABLED | TFS_PROFILER_ENABLED

/*  RelEnter
*/
#define RelEnter(_szLabel)                                      \
    {                                                           \
    static int iRelEnterUniqueAddress = 0;                      \
    static tfsChar * szRelEnterLabel = TfsStr(_szLabel);        \
    RelTraceEnter(szRelEnterLabel, &iRelEnterUniqueAddress);    \
    RelProfEnter(szRelEnterLabel, &iRelEnterUniqueAddress);

/*  RelLeave
*/
#define RelLeave()                                              \
    RelProfLeave(szRelEnterLabel, &iRelEnterUniqueAddress);     \
    RelTraceLeave(szRelEnterLabel, &iRelEnterUniqueAddress);    \
    }

#else

#define RelEnter(_szLabel)
#define RelLeave()

#endif
#endif

#endif /*  #ifndef _RLENTER_H */
