/*---------------------------------------------------------------------------
               ----> DO NOT REMOVE THE FOLLOWING NOTICE <----

      Copyright (c) 2003 - 2004 Datalight, Inc.  All Rights Reserved.

  Datalight, Incorporated is a Washington State corporation located at:

        21520 30th Dr SE, Suite 110,      Tel:  425-951-8086
        Bothell, WA  98021                Fax:  425-951-8094
        USA                               Http://www.datalight.com

  This software, including without limitation, all source code and documen-
  tation, is the confidential, trade secret property of Datalight, Inc., and
  is protected under the copyright laws of the United States and other juris-
  dictions.

  ---> Portions of the software are patent pending <---

  In addition to civil penalties for infringement of copyright under applic-
  able U.S. law, 17 U.S.C. 1204 provides criminal penalties for violation of
  (a) the restrictions on circumvention of copyright protection systems found
  in 17 U.S.C. 1201 and (b) the protections for the integrity of copyright
  management information found in 17 U.S.C. 1202.

  U.S. Government Restricted Rights:  Use, duplication, reproduction, or
  transfer of this commercial product and accompanying documentation is
  restricted in accordance with FAR 12.212 and DFARS 227.7202 and by a
  License Agreement.

  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS PROTECTED UNDER A
  SOURCE CODE AGREEMENT, NON-DISCLOSURE AGREEMENT (NDA), OR SIMILAR BINDING
  CONTRACT BETWEEN DATALIGHT, INC. AND THE LICENSEE ("BINDING AGREEMENT").
  YOUR RIGHT, IF ANY, TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,
  IS SUBJECT TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT.  BY USING
  THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE TO BE BOUND BY
  THE TERMS OF THE BINDING AGREEMENT.  CONTACT DATALIGHT, INC. AT THE ADDRESS
  SET FORTH ABOVE IF YOU OBTAINED THIS SOFTWARE IN ERROR.
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Description
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Revision History
    $Log: rlextapi.h $
    Revision 1.2  2006/03/29 22:05:01  brandont
    Added conditioned feature to look up a path based on an INode index.
    Revision 1.1  2005/07/01 01:24:30Z  Pauli
    Initial revision
    Revision 1.2  2005/07/01 02:24:30Z  Pauli
    Merge with 2.0 product line, build 458.
    Revision 1.7  2005/07/01 02:24:30Z  brandont
    Updated function prototypes for TfsMetaRootCDFWrite,
    TFSMetaRootCDFRead, TfsIMapSetEntry, TfsINodeCreate, and
    TfsINodeSetAttributes.
    Revision 1.6  2005/04/27 00:17:17Z  brandont
    Updated the prototype for TfsINodeCDFWrite.
    Revision 1.5  2005/04/15 20:42:20Z  brandont
    Revision 1.4  2005/04/15 20:42:20Z  brandont
    Sorted the prototypes by functionality groups.
    Revision 1.3  2005/04/13 04:43:27Z  brandont
    Updated the prototype for TfsMasterIsValid.
    Revision 1.2  2005/03/25 20:38:42Z  brandont
    Added prototype for TfsMasterCDFResetCheckSum.
    Revision 1.1  2005/02/26 01:56:26Z  brandont
    Initial revision
---------------------------------------------------------------------------*/

#ifndef __rlextapi_h
#define __rlextapi_h


TFSERR TfsVolumeSetCurrentVolume(
    sTfsVolume * pVolume);

void TfsMasterCDFRead(
    sTfsMasterBlock * pMaster);
void TfsMasterCDFWrite(
    sTfsMasterBlock * pMaster);
TFSERR TfsMasterIsValid(
    sTfsMasterBlock * pMaster);
void TfsMasterCDFResetCheckSum(
    tfsBuffer * pucCDFBuffer );

TFSERR TfsMetaRootIsValid(
    sTfsVolume * pVolume,
    tfsUint8 * pCDFMetaRoot,
    tfsUint32 * pulCounter,
    tfsBool * pfIsValid );
void TfsMetaRootSetSizes(
    sTfsVolume * pVolume,
    sTfsGeometry * pGeometry);
void TfsMetaRootCDFWrite(
    sTfsMetaRoot * pMetaRoot,
    tfsUint8 * pucCDFBuffer,
    tfsBlockSize ulBlockSize );
void TfsMetaRootCDFRead(
    sTfsMetaRoot * pInMemoryMetaRoot,
    tfsUint8 * pCDFMetaRoot,
    tfsBlockSize ulBlockSize );

tfsBool TfsIMapIsValid(
    sTfsIMap * pIMap);
unsigned TfsIMapGetEntry(
    sTfsIMap * pIMap,
    unsigned iEntry);
void TfsIMapSetEntry(
    sTfsVolume * pVolume,
    sTfsMetaRoot * pMetaRoot,
    unsigned uIMapEntries,
    sTfsIMap * pIMap,
    unsigned iEntry,
    unsigned iValue);

#if !REL_FEATURE_REVERSE_LOOKUP
void TfsINodeCreate(
    tfsBlockSize ulBlockSize,
    sTfsINode * pINode,
    tfsUint16 uAttributes,
    tfsIndex iIndex );
#else
void TfsINodeCreate(
    tfsBlockSize ulBlockSize,
    sTfsINode * pINode,
    tfsUint16 uAttributes,
    tfsIndex iIndex,
    tfsIndex ulParentIndex );
#endif
tfsBool TfsINodeCDFIsValid(
    void *pCDFBuffer);
void TfsINodeCDFRead(
    sTfsINode * pINode);
void TfsINodeCDFWrite(
    sTfsINode * pINode,
    tfsBool fUpdateDateTime );
void TfsINodeCreateIndirect(
    tfsBlockSize ulBlockSize,
    unsigned uINodeEntries,
    sTfsIndirect * pIndirect,
    tfsUint32 iSig,
    tfsIndex iIndex);
void TfsINodeSetAttributes(
    tfsUint16 * puFlags,
    tfsUint16 uBits,
    tfsUint16 uCareBits);

tfsBool TfsIndirectCDFIsValid(
    void *pCDFBuffer,
    tfsUint32 ulSignature);
void TfsIndirectCDFRead(
    sTfsIndirect * pIndirect);
void TfsIndirectCDFWrite(
    sTfsIndirect * pIndirect);

tfsBool TfsDirMatchName(
    tfsChar * szMask,
    int iMaskLen,
    tfsChar * szName,
    int iNameLen);


#endif /* #ifndef __rlextapi_h */
