/*---------------------------------------------------------------------------
               ----> DO NOT REMOVE THE FOLLOWING NOTICE <----

      Copyright (c) 2003 - 2004 Datalight, Inc.  All Rights Reserved.

  Datalight, Incorporated is a Washington State corporation located at:

        21520 30th Dr SE, Suite 110,      Tel:  425-951-8086
        Bothell, WA  98021                Fax:  425-951-8094
        USA                               Http://www.datalight.com

  This software, including without limitation, all source code and documen-
  tation, is the confidential, trade secret property of Datalight, Inc., and
  is protected under the copyright laws of the United States and other juris-
  dictions.

  ---> Portions of the software are patent pending <---

  In addition to civil penalties for infringement of copyright under applic-
  able U.S. law, 17 U.S.C. 1204 provides criminal penalties for violation of
  (a) the restrictions on circumvention of copyright protection systems found
  in 17 U.S.C. 1201 and (b) the protections for the integrity of copyright
  management information found in 17 U.S.C. 1202.

  U.S. Government Restricted Rights:  Use, duplication, reproduction, or
  transfer of this commercial product and accompanying documentation is
  restricted in accordance with FAR 12.212 and DFARS 227.7202 and by a
  License Agreement.

  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS PROTECTED UNDER A
  SOURCE CODE AGREEMENT, NON-DISCLOSURE AGREEMENT (NDA), OR SIMILAR BINDING
  CONTRACT BETWEEN DATALIGHT, INC. AND THE LICENSEE ("BINDING AGREEMENT").
  YOUR RIGHT, IF ANY, TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,
  IS SUBJECT TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT.  BY USING
  THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE TO BE BOUND BY
  THE TERMS OF THE BINDING AGREEMENT.  CONTACT DATALIGHT, INC. AT THE ADDRESS
  SET FORTH ABOVE IF YOU OBTAINED THIS SOFTWARE IN ERROR.
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Description

    Definitions for utilizing the "extent" module.

---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Revision History
    $Log: rlextent.h $
    Revision 1.1  2005/05/03 17:12:06  Pauli
    Initial revision
    Revision 1.1  2005/05/03 18:12:06Z  Garyp
    Initial revision
    Revision 1.1  2005/05/03 18:12:06Z  pauli
    Initial revision
    Revision 1.2  2005/05/03 18:12:05Z  PaulI
    Added a prototype for getting extent table information.
    Revision 1.1  2005/02/18 01:38:04Z  brandont
    Initial revision
---------------------------------------------------------------------------*/

#ifndef __rlextent_h
#define __rlextent_h


/*  for use with Extent handling, a single extent
*/
struct TfsTagExtent
{
    tfsBlock        iBlock;
    tfsBlock        iNumBlocks;
};


/*  each allocated entry looks like this
*/
struct TfsTagExtentTable
{
    tfsUint32       iSignature;
    tfsBlock        iNumRecords;        /* # of extent records in table */
    tfsBlock        iMaxRecords;
    tfsBlock        iNumBlocks; /* # of blocks represented by extents */
    tfsUint32       iExpandSize;        /* size in bytes to expand table */
    tfsBool         fExpandOk;  /* table can expand (or not) */
    sTfsExtent     *pEntries;   /* ptr to array of extents */
};


/*  for use with Extent handling, find next block
*/
struct TfsTagExtentFind
{
    tfsBlock        iExtent;
    tfsBlock        iEntry;
    sTfsExtent     *pExtent;
};
typedef struct TfsTagExtentFind sTfsExtentFind;


/*  parameter to TfsExtentInitialize()
*/
#define TFS_EXPAND          TFS_TRUE
#define TFS_DONT_EXPAND     TFS_FALSE


int TfsExtentInitialize( sTfsExtentTable ** ppTable, tfsUint32 iSize,
        tfsBool fExpandOk );
int TfsExtentUninitialize( sTfsExtentTable * pTable );
void TfsExtentSetExpand( sTfsExtentTable * pTable, tfsBool fExpandOk );
void TfsExtentClearTable( sTfsExtentTable * pTable );
tfsUint32 TfsExtentGetNumExtents( sTfsExtentTable * pTable );
tfsBlock TfsExtentGetNumBlocks( sTfsExtentTable * pTable );
tfsBool TfsExtentGetBlocks( sTfsExtentTable * pTable, tfsBlock * pArray,
        tfsBlock iEntry, tfsBlock iNumBlocks );
tfsBlock TfsExtentGetFirstBlock( sTfsExtentTable * pTable,
        sTfsExtentFind * pFind );
tfsBlock TfsExtentGetNextBlock( sTfsExtentTable * pTable,
        sTfsExtentFind * pFind );
sTfsExtent * TfsExtentGetEntryPtr( sTfsExtentTable * pTable,
        tfsBlock iExtent );
int TfsExtentAddBlock( sTfsExtentTable * pTable, tfsBlock iBlock,
        tfsBlock ulNumberOfBlocks );
int TfsExtentAddExtent( sTfsExtentTable * pTable, sTfsExtent * pExtent);
tfsBool TfsExtentIsBlockInTable( sTfsExtentTable * pTable,
        tfsBlock iBlock );
TFSERR TfsExtentGetExtentInfo( sTfsExtentTable * pTable, tfsUint32 * pulInitialSize, tfsUint32 * pulCurrentSize, tfsBool * pfGrowth );

#endif /* #ifndef __rlextent_h */
