/*---------------------------------------------------------------------------
               ----> DO NOT REMOVE THE FOLLOWING NOTICE <----

      Copyright (c) 2003 - 2004 Datalight, Inc.  All Rights Reserved.

  Datalight, Incorporated is a Washington State corporation located at:

        21520 30th Dr SE, Suite 110,      Tel:  425-951-8086
        Bothell, WA  98021                Fax:  425-951-8094
        USA                               Http://www.datalight.com

  This software, including without limitation, all source code and documen-
  tation, is the confidential, trade secret property of Datalight, Inc., and
  is protected under the copyright laws of the United States and other juris-
  dictions.

  ---> Portions of the software are patent pending <---

  In addition to civil penalties for infringement of copyright under applic-
  able U.S. law, 17 U.S.C. 1204 provides criminal penalties for violation of
  (a) the restrictions on circumvention of copyright protection systems found
  in 17 U.S.C. 1201 and (b) the protections for the integrity of copyright
  management information found in 17 U.S.C. 1202.

  U.S. Government Restricted Rights:  Use, duplication, reproduction, or
  transfer of this commercial product and accompanying documentation is
  restricted in accordance with FAR 12.212 and DFARS 227.7202 and by a
  License Agreement.

  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS PROTECTED UNDER A
  SOURCE CODE AGREEMENT, NON-DISCLOSURE AGREEMENT (NDA), OR SIMILAR BINDING
  CONTRACT BETWEEN DATALIGHT, INC. AND THE LICENSEE ("BINDING AGREEMENT").
  YOUR RIGHT, IF ANY, TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,
  IS SUBJECT TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT.  BY USING
  THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE TO BE BOUND BY
  THE TERMS OF THE BINDING AGREEMENT.  CONTACT DATALIGHT, INC. AT THE ADDRESS
  SET FORTH ABOVE IF YOU OBTAINED THIS SOFTWARE IN ERROR.
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Description
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Revision History
    $Log: rlfmt.h $
    Revision 1.2  2006/01/26 04:28:04  brandont
     Merged with Reliance 2.0 code base.
    Revision 1.5  2006/01/12 02:48:39Z  brandont
    Moved I/O layer function pointer prototypes to rloilapi.h.
    Revision 1.4  2005/12/01 00:16:07Z  brandont
    Added I/O layer function prototypes and a prototype for a function to
    call that will override the I/O layer used by the formatter.
    Revision 1.1  2005/03/09 04:01:24Z  Pauli
    Initial revision
    Revision 1.1  2005/03/09 04:01:24Z  Garyp
    Initial revision
    Revision 1.1  2005/03/09 03:01:24Z  pauli
    Initial revision
    Revision 1.3  2005/03/09 02:01:24Z  brandont
    Removed the old progress function typedef.  Updated the argument list
    for the format API.
    Revision 1.2  2005/03/01 02:07:47Z  brandont
    Updated the RelToolFormatParm prototype.
    Revision 1.1  2005/02/08 00:35:12Z  brandont
    Initial revision
---------------------------------------------------------------------------*/


#ifndef __rlfmt_h
#define __rlfmt_h


TFSERR RelToolFormatParm(
    tfsChar * szOilUtilityName,
    tfsChar * pDevice,
    tfsBlockSize ulRequestedBlockSize,
    tfsBool fPerformSurfaceScan,
    tfsBool fQuietMode,
    tfsBool fShowSummary,
    tfsBool fShowProgress,
    fnRelProgress fnProgress );


TFSERR RelToolFormat(
    tfsChar * szOilUtilityName,
    tfsChar * szExtraUsage,
    int argc,
    tfsChar * argv[] );


/*  RelFmtSetIoMapping

    Override the formatter I/O functions.
*/
void RelFmtSetIoMapping(
    tDeviceNameToIo pDeviceNameToIo,
    tIoInitialize pIoInitialize,
    tIoGetVolumeGeometry pIoGetVolumeGeometry,
    tIoSetVolumeGeometry pIoSetVolumeGeometry,
    tIoDiscardBlocks pIoDiscardBlocks,
    tIoVerify pIoVerify,
    tIoWrite pIoWrite,
    tIoReset pIoReset,
    tIoFlush pIoFlush,
    tIoForceMediaChange pIoForceMediaChange,
    tIoUninitialize pIoUninitialize );


#endif /* __rlfmt_h */
