/*---------------------------------------------------------------------------
               ----> DO NOT REMOVE THE FOLLOWING NOTICE <----

      Copyright (c) 2003 - 2004 Datalight, Inc.  All Rights Reserved.

  Datalight, Incorporated is a Washington State corporation located at:

        21520 30th Dr SE, Suite 110,      Tel:  425-951-8086
        Bothell, WA  98021                Fax:  425-951-8094
        USA                               Http://www.datalight.com

  This software, including without limitation, all source code and documen-
  tation, is the confidential, trade secret property of Datalight, Inc., and
  is protected under the copyright laws of the United States and other juris-
  dictions.

  ---> Portions of the software are patent pending <---

  In addition to civil penalties for infringement of copyright under applic-
  able U.S. law, 17 U.S.C. 1204 provides criminal penalties for violation of
  (a) the restrictions on circumvention of copyright protection systems found
  in 17 U.S.C. 1201 and (b) the protections for the integrity of copyright
  management information found in 17 U.S.C. 1202.

  U.S. Government Restricted Rights:  Use, duplication, reproduction, or
  transfer of this commercial product and accompanying documentation is
  restricted in accordance with FAR 12.212 and DFARS 227.7202 and by a
  License Agreement.

  IN ADDITION TO COPYRIGHT AND PATENT LAW, THIS SOFTWARE IS PROTECTED UNDER A
  SOURCE CODE AGREEMENT, NON-DISCLOSURE AGREEMENT (NDA), OR SIMILAR BINDING
  CONTRACT BETWEEN DATALIGHT, INC. AND THE LICENSEE ("BINDING AGREEMENT").
  YOUR RIGHT, IF ANY, TO COPY, PUBLISH, MODIFY OR OTHERWISE USE THE SOFTWARE,
  IS SUBJECT TO THE TERMS AND CONDITIONS OF THE BINDING AGREEMENT.  BY USING
  THE SOFTWARE IN ANY MANNER, IN WHOLE OR IN PART, YOU AGREE TO BE BOUND BY
  THE TERMS OF THE BINDING AGREEMENT.  CONTACT DATALIGHT, INC. AT THE ADDRESS
  SET FORTH ABOVE IF YOU OBTAINED THIS SOFTWARE IN ERROR.
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Description

    Declarations and macros for tfsmunge.c and tfumunge.c.

---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
                              Revision History
    $Log: rlmunge.h $
    Revision 1.1  2005/02/23 04:20:46  Pauli
    Initial revision
    Revision 1.1  2005/02/23 04:20:46Z  Garyp
    Initial revision
    Revision 1.1  2005/02/23 03:20:46Z  pauli
    Initial revision
    Revision 1.3  2005/02/23 02:20:45Z  brandont
    Added munge tool function prototype.
    Revision 1.2  2004/12/31 01:17:53Z  GaryP
    Updated to use indents of 4, hard tabs of 8 (if used), and a standard
    comment style.
    Revision 1.1  2004/09/23 00:49:06Z  brandont
    Initial revision
    Revision 1.2  2004/08/27 00:35:16  brandont
    - IR ? *.* Changed header on all the source modules to the FlashFx style header
---------------------------------------------------------------------------*/

#ifndef TFS_MUNGE_H
#define TFS_MUNGE_H  1


/*  error codes that are currently unique to the Munger
*/
#define TFSERR_MUNGER_BASE                100
#define TFSERR_MUNGER_COMMIT_FAILED          TFSERR_MUNGER_BASE + 0
#define TFSERR_MUNGER_INVALID_MASTER_BLOCK      TFSERR_MUNGER_BASE + 1
#define TFSERR_MUNGER_TRANSACTION_FAILED     TFSERR_MUNGER_BASE + 2
#define TFSERR_MUNGER_SAVEFILE_CREATE_FAILED TFSERR_MUNGER_BASE + 3
#define TFSERR_MUNGER_INVALID_METAROOT       TFSERR_MUNGER_BASE + 4
#define TFSERR_MUNGER_UNREADABLE_METAROOT    TFSERR_MUNGER_BASE + 5


/*  flags for use with giTfsMungeOptions
*/
#define TFS_MUNGE_VERBOSE        0x00000001UL
#define TFS_MUNGE_MASTER         0x00000002UL
#define TFS_MUNGE_EVERYTHING     0x00000004UL
#define TFS_MUNGE_INDEX_ENTRY    0x00000008UL
#define TFS_MUNGE_MASTER_CHKSUM  0x00000010UL
#define TFS_MUNGE_MASTER_SIG     0x00000020UL


int TfsMungeVolume(
    sTfsVolume * pVolume,
    tfsUint32 TfsMungeOptions);


#endif /* TFS_CHECK_H */
