/* mip6_had.c - MIP6 home agent header file */

/* Copyright 2005 Wind River Systems, Inc. */


/*
modification history
--------------------
01e,01oct05,tlu  enable MIP6 HA
01d,01sep05,tlu  rename mip6 file name
01c,14jun05,tlu  add _cplusplus condition
01b,31may05,tlu  rename constants.h
01a,20apr05,tlu  initial creation
*/


#if !defined (_HAD_H_) 
#define _HAD_H_

#ifdef __cplusplus
extern "C" {
#endif


#include <mip6/mip6_constants.h>
#include <mip6/mip6.h>


/* HA data structure */
typedef struct HA_CLASS
{
    /* Configuration data */
    char ifname[V6ADDRPRESZ];
    int preference;
    int debug;

    /* semaphore used to protect global data structures */
    SEM_ID  ha_data_mutex;

    /* task */
    TASK_DESCRIPTOR ha_tasks[1];  /* HA task */

} HA_CLASS;


STATUS mip6CfgHaDaemon();
STATUS ha_initialize_env();
STATUS ha_create_tasks();
STATUS ha_daemon_task_entry_ptr();


#ifdef __cplusplus
}
#endif

#endif /* _HAD_H_ */
