/*	$ID: $	*/

/* Copyright (c) 2005 Wind River Systems, Inc.  */

/*
 * Copyright (C) 1995, 1996, 1997, and 1998 WIDE Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
modification history
--------------------
01b,16nov05,tlu  define if_bclreq structure to retrieve bc list through ioctl
01a,09may05,rp   ported from kame v1.1
*/

#ifndef _NET_IF_MIP_H_
#define _NET_IF_MIP_H_

#ifdef __cplusplus
extern "C" {
#endif

#define MIP_MTU 1280

struct mip_softc {
	struct ifnet          mip_if;
	LIST_ENTRY(mip_softc) mip_entry;
};
LIST_HEAD(mip_softc_list, mip_softc);

struct bul6info {
        struct in6_addr     bul_peeraddr;   /* peer addr of this BU */
        struct in6_addr     bul_hoa;        /* HoA */
        struct in6_addr     bul_coa;        /* CoA */
        u_int16_t           bul_flags;      /* Flag Ack, LL, Key, Home flag */
	u_int16_t           bul_ifindex;
	u_int16_t           bul_bid;        /* Binding Unique Identifier */
};

struct if_bulreq {
        char    ifbu_ifname[IFNAMSIZ];
	int     ifbu_len;
	int               ifbu_count;
	struct bul6info   *ifbu_info;
};


struct bcl6info {
        struct in6_addr     bcl_cnaddr;   /* cnaddr of this BC */
        struct in6_addr     bcl_hoa;        /* HoA */
        struct in6_addr     bcl_coa;        /* CoA */
        u_int16_t           bcl_flags;      /* Flag Ack, LL, Key, Home flag */
        u_int16_t           bcl_bid;        /* Binding Unique Identifier */
	u_int16_t	    bcl_proxydad_state;  /* Proxy DAD state */
};

struct if_bclreq {
        char    ifbc_ifname[IFNAMSIZ];
        int     ifbc_len;
        int     ifbc_count;
        struct bcl6info   *ifbc_info;
};


#ifdef _WRS_KERNEL

#ifndef VIRTUAL_STACK
extern struct mip_softc_list _mip_softc_list;
#endif /* VIRTUAL_STACK */

int mip_ioctl(struct ifnet *, u_long, caddr_t);
int mip_output(struct ifnet *, struct mbuf *, struct sockaddr *,
    struct rtentry *rt);

int mip_is_mip_softc(struct ifnet *);

#endif /* _WRS_KERNEL*/

#ifdef __cplusplus
}
#endif

#endif /* !_NET_IF_MIP_H_ */
