/* radius_utils.h */

/* Declarations of RADIUS utility functions.*/

/* Copyright 1984 - 2006 Wind River Systems, Inc. */
#include "copyright_wrs.h"

/*
modification history
____________________
01c,20jan06,snd Added radius_printf declaration,Fix for SPR 113557
01b,07nov05,snd Added cplusplus header and declarations for RWOS removal
01a,19dec00,md  merged from visual source safe
*/

#ifndef __INCradius_utilsh
#define __INCradius_utilsh
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


void radius_utils_load ();

bool radius_util_serialize_ulong (UINT ulong_to_be_converted, BYTE* buffer);
bool radius_util_serialize_ushort (USHORT ushort_to_be_converted, BYTE* buffer);

bool radius_util_deserialize_ulong (BYTE* buffer, ULONG *p_converted_ulong);
bool radius_util_deserialize_ushort (BYTE* buffer, USHORT *p_converted_ushort);

UINT radius_deserialize_byte (BYTE** ptr_to_bptr_location);
UINT radius_deserialize_ushort (BYTE** ptr_to_usptr_location);
ULONG radius_deserialize_ulong (BYTE** ptr_to_ulptr_location);
void radius_serialize_byte (UINT source, BYTE** ptr_to_bptr_destination);
void radius_serialize_ushort (UINT source, BYTE** ptr_to_usptr_destination);
void radius_serialize_ulong (ULONG source, BYTE** ptr_to_ulptr_destination);
void radius_printf (enum RADIUS_PRINTF_GROUPS printf_group,const char *cptr_format, ...);
#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* __INCradius_utilsh */
